unit BoraszClasses;

interface                                               //*********************INTERFACE*****************

uses SysUtils, Dialogs, Graphics, Classes;

const
// VENDEG ELMENETELEKOR
     VendegPremium : Integer = 1000;       // ennyit keres a vendeg az uzleten kivul (ahanyszor elmegy)
     AlkMinus : Integer = 4;               // ennyivel csokken az alkoholszintje (ahanyszor elmegy)
// MAXIMUMOK
     BorokSzama : Integer = 6;
     KellekekSzama : Integer = 4;
     VendegekSzama : Integer = 6;
// ARLISTA
     BorArMerlot : Integer =330;
     BorArBikaver : Integer =210;
     BorArKekfrankos : Integer =110;
     BorArAszu : Integer =370;
     BorArOlaszrizling : Integer =150;
     BorArSzamorodni : Integer =270;
     KellekArKanna : Integer =220;
     KellekArSajt : Integer =430;
     KellekArPohar : Integer =510;
     KellekArTerito : Integer =670;
// BORASZVALOSZINUSEGEK SZAZALEKBAN
     BVLeltaraz : Integer = 10;
     BVBorthoz : Integer = 40;        // ez a BVVasarol-lal osszesen max 100 lehet!!!
     BVVasarol : Integer = 40;        // ez a BVBorthoz-zal osszesen max 100 lehet!!!
     BVKiszolgal : Integer = 75;
// VENDEGVALOSZINUSEGEK SZAZALEKBAN
     VVErkezik : Integer = 8;
     VVKostol : Integer = 75;         // ez a VVRendel-lel osszesen max 100 lehet!!!
     VVRendel : Integer = 6;         // ez a VVKostol-lal osszesen max 100 lehet!!!

     VVSemmi : Integer = 25;          // ezek igy negyen aranyosan osszak fel a 100%-ot!!!
     VVLeont : Integer = 25;          //
     VVEszik : Integer = 25;          //
    //VVTor : Integer =25;            //   ez ugyis a 100-elsoharom
// ELLENOR ELJOVETELENEK VALOSZINUSEGE SZAZALEKBAN
     EVJon : Integer = 5;

type                                                    // DOLOG
    TDolog = class
    private
    Fajta : String;
    Egyseg : String;
    Mennyiseg : Integer;
    Ar : Integer;
    public
    constructor Init (f,e : String; m,a : Integer);
    function GetFajta : String;
    function GetEgyseg : String;
    function GetMennyiseg : Integer;
    function GetAr : Integer;
    procedure SetFajta (f : String);
    procedure SetEgyseg (e : String);
    procedure SetMennyiseg (m : Integer);
    procedure SetAr (a : Integer);
end;

type                                                    // HELY
    THely = class
    private
    Nev : String;
    Nyitva : Boolean;
    public
    constructor Init (n: String; ny : Boolean); virtual;
    function GetNev : String;
    function GetNyitva : Boolean;
    procedure SetNev(n : String);
    procedure SetNyitva (ny : Boolean);
end;

type                                                    // EMBER
    TEmber = class
    private
    Nev : String;
    Holvan : THely;
    public
    constructor Init (n : String); virtual;
    function GetNev : String;
    function GetHolvan : THely;
    procedure SetNev (n : String);
    procedure SetHolvan (h : THely);
    function Elmegy (h : THely) : Integer; virtual;
    function Kiir : String; virtual;                // csak a dinamikus kotes miatt
end;

type                                                    // TENNIVALO
    TTennivalo = class
    private
    Fajta : String;
    Ido : Integer;
    public
    constructor Init (i : Integer); virtual;
    function GetIdo : Integer;
    procedure SetIdo (i : Integer);
    function GetFajta : String;
    procedure SetFajta (f : String);
end;

type                                                      // SZAKBOLT
    TSzakbolt = class (THely)
    private
    Kellekek : TList;
    public
    constructor Init (n : String; ny : Boolean); override;
    destructor Destroy; override;
    function GetCountKellekek : Integer;
    function GetItemKellekek (i : Integer) : Pointer;
    function IsKellek(d : TDolog) : Boolean;
    function SearchKellek (d : TDolog) : Integer;overload;
    function SearchKellek (s : String) : Pointer;overload;
    function GetCountKanna : Integer;
    function GetCountSajt : Integer;
    function GetCountTerito : Integer;
    function GetCountPohar : Integer;
    function GetFirstKanna : TDolog;
    function GetFirstSajt : TDolog;
    function GetFirstTerito : TDolog;
    function GetFirstPohar : TDolog;
    procedure AddKellek (f,e : String; m,a : Integer);
    procedure DelKellek (i : Integer);
end;

type                                                      // PINCE
    TPince = class (THely)
    private
    Borok : TList;
    public
    constructor Init (n : String; ny : Boolean); override;
    destructor Destroy; override;
    function GetCountBorok : Integer;
    function GetItemBorok (i : Integer) : Pointer;
    function SearchBor (b : String) : TDolog;
    procedure AddBor (f,e : String; m,a : Integer);
    procedure DelBor (i : Integer);
end;

type                                                     // VENDEG
    TVendeg = class (TEmber)
    private
    Penz : Integer;
    AlkoholSzint : Integer;
    Rendelt : Integer;
    public
    constructor Init (n : String); override;
    function GetPenz : Integer;
    function GetAlkoholSzint : Integer;
    function GetRendelt : Integer;
    procedure SetRendelt (i : Integer);
    procedure SetPenz (p : Integer);
    procedure SetAlkoholSzint (a : Integer);
    function Kiir : String; override;              //csak a dinamikus kotes miatt

    function Kostol (b : TDolog) : Integer;
    function Rendel (b : TEmber) : TTennivalo;
    function Elmegy (h : THely) : Integer; override;
end;

type                                                     // UZLET
    TUzlet = class (THely)
    private
    Kellekek : TList;
    Borok : TList;
    Vendegek : TList;
    VanEllenor : Boolean;
    public
    constructor Init (n : String; ny : Boolean); override;
    destructor Destroy; override;
    function GetCountKellekek : Integer;
    function GetItemKellekek(i : Integer) : Pointer;
    function IsKellek(d : TDolog) : Boolean;
    function SearchKellek (d : TDolog) : Integer; overload;
    function SearchKellek (s : String) : Pointer; overload;
    function GetCountKanna : Integer;
    function GetCountSajt : Integer;
    function GetCountTerito : Integer;
    function GetCountPohar : Integer;
    function GetFirstKanna : TDolog;
    function GetFirstSajt : TDolog;
    function GetFirstTerito : TDolog;
    function GetFirstPohar : TDolog;
    procedure SetVanEllenor(b : Boolean);
    function GetVanEllenor : Boolean;
    procedure AddKellek (f,e : String; m,a : Integer);
    procedure DelKellek (i : Integer);

    function GetCountBorok : Integer;
    function GetItemBorok(i : Integer) : Pointer;
    function SearchBor (b : String) : TDolog;
    procedure AddBor (f,e : String; m,a : Integer);
    procedure DelBor (i : Integer);

    procedure SetItemVendegek (i : Integer; p : Pointer);
    procedure VendegekPack;
    function IsVendeg (v : TVendeg) : Boolean;
    function GetCountVendegek : Integer;
    function SearchVendeg (v : TVendeg) : Integer; overload;
    function SearchVendeg (s : String) : Integer; overload;
    function GetItemVendegek(i : Integer) : Pointer;
    procedure AddVendeg(v : TVendeg);
    procedure DelVendeg(i : Integer);
end;

type                                                      // BORTHOZ
    TBorthoz = class (TTennivalo)
    private
    Borok : TList;
    public
    constructor Init (i : Integer); override;
    destructor Destroy; override;
    function GetCountBorok : Integer;
    function GetItemBorok (i : Integer) : Pointer;
    function SearchBor (b : String) : TDolog;
    procedure AddBor (f,e : String; m,a : Integer);
    procedure DelBor (i : Integer);
end;

type                                                      // VASAROL
    TVasarol = class (TTennivalo)
    private
    Kellekek : TList;
    public
    constructor Init (i : Integer); override;
    destructor Destroy; override;
    function GetCountKellekek : Integer;
    function GetItemKellekek(i : Integer) : Pointer;
    function SearchKellek(k : String) : TDolog;
    procedure AddKellek (f,e : String; m,a : Integer);
    procedure DelKellek (i : Integer);
end;

type                                                      // KISZOLGAL
    TKiszolgal = class (TTennivalo)
    private
    Vendeg : TVendeg;
    Borok : TList;
    public
    constructor Init (i: Integer); override;
    destructor Destroy; override;
    function GetVendeg : TVendeg;
    procedure SetVendeg (v : TVendeg);
    function GetCountBorok : Integer;
    function GetItemBorok (i : Integer) : Pointer;
    function SearchBor (b : String) : TDolog;
    procedure AddBor (f,e : String; m,a : Integer);
    procedure DelBor (i : Integer);
end;

type                                                     // BORASZ
    TBorasz = class (TEmber)
    private
    Penz : Integer;
    Tennivalo : TList;
    Uzlet : TUzlet;
    Pince : TPince;
    Szakbolt : TSzakbolt;
    Ido : Integer;
    MitCsinal : Integer;
    public
    constructor Init (n : String); override;
    destructor Destroy; override;
    function GetPenz : Integer;
    procedure SetPenz (p : Integer);
    function GetUzlet : TUzlet;
    procedure SetUzlet (u : TUzlet);
    function GetPince : TPince;
    procedure SetPince (p : TPince);
    function GetSzakbolt : TSzakbolt;
    procedure SetSzakbolt (sz : TSzakbolt);
    procedure SetIdo (i : Integer);
    function GetIdo : Integer;
    procedure AddIdo (i : Integer);
    procedure DecIdo (i : Integer);
    procedure SetMitCsinal (i : Integer);
    function GetMitCsinal : Integer;
    function Kiir : String; override;         // csak a dinamikus kotes miatt

    function GetCountTennivalo : Integer;
    function GetItemTennivalo (i : Integer) : Pointer;
    function IsTennivalo (t : TTennivalo) : Boolean;
    function SearchTennivalo (t : TTennivalo) : Integer; overload;
    function SearchTennivalo (s : String) : Integer; overload;
    procedure AddTennivalo (t : TTennivalo);
    procedure DelTennivalo (i : Integer);
    procedure TennivaloPack;
    function GetCountVasarlas : Integer;
    function GetCountBorhozas : Integer;
    function GetCountKiszolgalas : Integer;
    function GetFirstBorhozas : TBorthoz;
    function GetFirstVasarlas : TVasarol;
    function GetFirstKiszolgalas : TKiszolgal;
    procedure ClearKiszolgal;

    function Vasarol : Integer;
    function Borthoz : Integer;
    procedure Nyit;
    procedure Zar;
    function Kiszolgal : Integer;
    procedure Leltaraz;
    function Elmegy (h : THely) : Integer; override;
end;

type                                                     // ELLENOR
    TEllenor = class (TEmber)
    private
    Hangulat : String;
    Lepes : Integer;
    Mehet : Boolean;
    public
    constructor Init (n : String); override;
    function GetHangulat : String;
    procedure SetHangulat (h : String);
    function GetMehet : Boolean;
    procedure SetMehet(b : Boolean);
    procedure Buntet (b : TBorasz; o : Integer);
    procedure Jutalmaz (b : TBorasz; o : Integer);
    procedure Kiurittet (b : TBorasz);
    function Vizsgal (b : TBorasz) :  Integer;
    function Elmegy (h : THely) : Integer; override;
    function Kiir : String; override;                  //csak a dinamikus kotes miatt
end;


var
  Sehol : THely;



implementation                                             // *************IMPLEMENTATION***************

constructor TEmber.Init (n : String);                      // EMBER
begin
Nev := n;
Holvan := Sehol;
end;

function TEmber.GetNev : String;
begin
Result := Nev;
end;

function TEmber.GetHolvan : THely;
begin
Result := Holvan;
end;

procedure TEmber.SetNev (n : String);
begin
Nev := n;
end;

procedure TEmber.SetHolvan (h : THely);
begin
Holvan := h;
end;

function TEmber.Elmegy (h : THely) : Integer;
begin
Result := 0;
if (Holvan <> h) then
  begin
  Holvan := h;
  Result := 1;
  end;
end;

function TEmber.Kiir: String;
begin
Result := 'Ez egy sima TEmber';
end;

constructor TDolog.Init (f,e : String; m,a : Integer);     //DOLOG
begin
Fajta := f;
Egyseg := e;
Mennyiseg := m;
Ar:= a;
end;

function TDolog.GetFajta : String;
begin
Result := Fajta;
end;

function TDolog.GetEgyseg : String;
begin
Result := Egyseg;
end;

function TDolog.GetMennyiseg : Integer;
begin
Result := Mennyiseg;
end;

function TDolog.GetAr : Integer;
begin
Result := Ar;
end;

procedure TDolog.SetFajta (f : String);
begin
Fajta := f;
end;

procedure TDolog.SetEgyseg (e : String);
begin
Egyseg := e;
end;

procedure TDolog.SetMennyiseg (m : Integer);
begin
if (m<0) then m:=0;
Mennyiseg := m;
end;

procedure TDolog.SetAr (a : Integer);
begin
if (a<0) then a:=1;
Ar := a;
end;

constructor THely.Init (n : String; ny : Boolean);    // HELY
begin
Nev := n;
Nyitva := ny;
end;

function THely.GetNev : String;
begin
Result := Nev;
end;

function THely.GetNyitva : Boolean;
begin
Result := Nyitva;
end;


procedure THely.SetNev(n : String);
begin
Nev := n;
end;

procedure THely.SetNyitva (ny : Boolean);
begin
Nyitva := ny;
end;

constructor TTennivalo.Init (i : Integer);                 // TENNIVALO
begin
Ido := i;
Fajta := 'Semmilyen';
end;

function TTennivalo.GetIdo : Integer;
begin
Result := Ido;
end;

function TTennivalo.GetFajta : String;
begin
Result := Fajta;
end;

procedure TTennivalo.SetFajta (f : String);
begin
Fajta := f;
end;

procedure TTennivalo.SetIdo (i : Integer);
begin
if (i<0) then i:=1;
Ido := i;
end;

constructor TBorasz.Init (n : String);                    // BORASZ
begin
inherited Init(n);
Penz := 0;
Tennivalo := TList.Create;
Tennivalo.Capacity := 50;
Uzlet := nil;
Pince := nil;
Szakbolt := nil;
MitCsinal := 0;
Ido := 0;
end;

destructor TBorasz.Destroy;
begin
Tennivalo.Free;
end;

function TBorasz.GetPenz : Integer;
begin
Result := Penz;
end;

procedure TBorasz.SetPenz (p : Integer);
begin
if (p<0) then p:=0;
Penz := p;
end;

function TBorasz.GetItemTennivalo (i : Integer) : Pointer;
begin
Result := Tennivalo[i];
end;

function TBorasz.IsTennivalo (t : TTennivalo) : Boolean;
begin
if (Tennivalo.IndexOf(t) = -1) then Result := False
                               else Result := True;
end;

function TBorasz.SearchTennivalo (t : TTennivalo) : Integer;
begin
Result := Tennivalo.IndexOf(t);
end;

function TBorasz.SearchTennivalo (s : String) : Integer;
var
  i : Integer;
begin
Result := -1;
for i:=1 to Tennivalo.Count do
    begin
    if (Tennivalo[i-1]=nil) then Continue;
    if (TTennivalo(Tennivalo[i-1]).GetFajta = s) then
        begin
        Result:=i-1;
        Exit;
        end;
    end;
end;

procedure TBorasz.AddTennivalo (t : TTennivalo);
begin
Tennivalo.Add(t);
end;

procedure TBorasz.DelTennivalo (i : Integer);
begin
Tennivalo[i] := nil;
Tennivalo.Pack;
end;

function TBorasz.Kiir: String;
begin
Result := 'Ez pedig TBorasz';
end;

function TBorasz.GetCountVasarlas : Integer;
var
  i : Integer;
begin
Result := 0;
for i:=1 to GetCountTennivalo do
    begin
    if (GetItemTennivalo(i-1)=nil) then Continue;
    if (TTennivalo(GetItemTennivalo(i-1)).GetFajta = 'Vsrls') then Result := Result + 1;
    end;
end;

function TBorasz.GetCountBorhozas : Integer;
var
  i : Integer;
begin
Result := 0;
for i:=1 to GetCountTennivalo do
    begin
    if (GetItemTennivalo(i-1)=nil) then Continue;
    if (TTennivalo(GetItemTennivalo(i-1)).GetFajta = 'Borhozs') then Result := Result + 1;
    end;
end;

function TBorasz.GetCountKiszolgalas : Integer;
var
  i : Integer;
begin
Result := 0;
for i:=1 to GetCountTennivalo do
    begin
    if (GetItemTennivalo(i-1)=nil) then Continue;
    if (TTennivalo(GetItemTennivalo(i-1)).GetFajta = 'Kiszolgls') then Result := Result + 1;
    end;
end;

function TBorasz.GetCountTennivalo : Integer;
begin
Result := Tennivalo.Count;
end;

function TBorasz.GetUzlet : TUzlet;
begin
Result := Uzlet;
end;

procedure TBorasz.SetUzlet(u : TUzlet);
begin
Uzlet := u;
end;

function TBorasz.GetPince : TPince;
begin
Result := Pince;
end;

procedure TBorasz.SetPince (p : TPince);
begin
Pince := p;
end;

function TBorasz.GetFirstBorhozas : TBorthoz;
var
  i : Integer;
begin
Result := nil;
if (GetCountBorhozas<>0) then
  begin
  for i:=1 to Tennivalo.Count do
      begin
      if (Tennivalo[i-1]=nil) then Continue;
      if (TTennivalo(Tennivalo[i-1]).GetFajta = 'Borhozs') then
          begin
          Result := TBorthoz(Tennivalo[i-1]);
          Exit;
          end;
      end;
  end;
end;

function TBorasz.GetFirstVasarlas : TVasarol;
var
  i : Integer;
begin
Result := nil;
if (GetCountVasarlas<>0) then
  begin
  for i:=1 to Tennivalo.Count do
      begin
      if (Tennivalo[i-1]=nil) then Continue;
      if (TTennivalo(Tennivalo[i-1]).GetFajta = 'Vsrls') then
          begin
          Result := TVasarol(Tennivalo[i-1]);
          Exit;
          end;
      end;
  end;
end;

function TBorasz.GetFirstKiszolgalas : TKiszolgal;
var
  i : Integer;
begin
Result := nil;
if (GetCountKiszolgalas<>0) then
  begin
  for i:=1 to Tennivalo.Count do
      begin
      if (Tennivalo[i-1]=nil) then Continue;
      if (TTennivalo(Tennivalo[i-1]).GetFajta = 'Kiszolgls') then
          begin
          Result := TKiszolgal(Tennivalo[i-1]);
          Exit;
          end;
      end;
  end;
end;

function TBorasz.GetSzakbolt : TSzakbolt;
begin
Result := Szakbolt;
end;

procedure TBorasz.TennivaloPack;
begin
Tennivalo.Pack;
end;

procedure TBorasz.SetSzakbolt (sz : TSzakbolt);
begin
Szakbolt := sz;
end;

procedure TBorasz.SetIdo (i : Integer);
begin
if (i<0) then i:=0;
Ido := i;
end;

function TBorasz.GetIdo : Integer;
begin
Result := Ido;
end;

procedure TBorasz.AddIdo (i : Integer);
begin
if (i<0) then i:=0;
Ido := Ido + i;
end;

procedure TBorasz.DecIdo (i : Integer);
begin
if (i<0) then i:=0;
Ido := Ido - i;
if (Ido < 0) then Ido := 0;
end;

procedure TBorasz.SetMitCsinal (i : Integer);
begin
if (i<0) then i:=0;
MitCsinal := i;
end;

function TBorasz.GetMitCsinal : Integer;
begin
Result := MitCsinal;
end;

function TBorasz.Vasarol : Integer;
var
  index : Integer;
  i : Integer;
begin
Result := -1;
if (GetCountVasarlas = 0) then Exit;
index := Tennivalo.IndexOf(GetFirstVasarlas);
if (index = -1) then Exit;
Result := -2;
if (TVasarol(Tennivalo[index]).GetCountKellekek = 0) then
        begin
        DelTennivalo(index);
        Exit;
        end;
index := Tennivalo.IndexOf(GetFirstVasarlas);
for i:=1 to TVasarol(Tennivalo[index]).GetCountKellekek do
    begin
    if (Penz - (TDolog(TVasarol(Tennivalo[index]).GetItemKellekek(i-1)).GetMennyiseg * TDolog(TVasarol(Tennivalo[index]).GetItemKellekek(i-1)).GetAr) < 0) then Continue;
    Penz := Penz - (TDolog(TVasarol(Tennivalo[index]).GetItemKellekek(i-1)).GetMennyiseg * TDolog(TVasarol(Tennivalo[index]).GetItemKellekek(i-1)).GetAr);
    TDolog(Szakbolt.SearchKellek(TDolog(TVasarol(Tennivalo[index]).GetItemKellekek(i-1)).GetFajta)).SetMennyiseg(TDolog(Szakbolt.SearchKellek(TDolog(TVasarol(Tennivalo[index]).GetItemKellekek(i-1)).GetFajta)).GetMennyiseg - TDolog(TVasarol(Tennivalo[index]).GetItemKellekek(i-1)).GetMennyiseg);
    TDolog(Uzlet.SearchKellek(TDolog(TVasarol(Tennivalo[index]).GetItemKellekek(i-1)).GetFajta)).SetMennyiseg(TDolog(Uzlet.SearchKellek(TDolog(TVasarol(Tennivalo[index]).GetItemKellekek(i-1)).GetFajta)).GetMennyiseg + TDolog(TVasarol(Tennivalo[index]).GetItemKellekek(i-1)).GetMennyiseg);
    if (TDolog(Szakbolt.SearchKellek(TDolog(TVasarol(Tennivalo[index]).GetItemKellekek(i-1)).GetFajta)).GetMennyiseg < 5000) then TDolog(Szakbolt.SearchKellek(TDolog(TVasarol(Tennivalo[index]).GetItemKellekek(i-1)).GetFajta)).SetMennyiseg(9999);
    end;
DelTennivalo(index);
Elmegy(Uzlet);
Result := 1;
end;

function TBorasz.Borthoz : Integer;
var
  index : Integer;
  i : Integer;
begin
Result := -1;
if (GetCountBorhozas = 0) then Exit;
index := Tennivalo.IndexOf(GetFirstBorhozas);
if (index = -1) then Exit;
Result := -2;
if (TBorthoz(Tennivalo[index]).GetCountBorok = 0) then
        begin
        DelTennivalo(index);
        Exit;
        end;
index := Tennivalo.IndexOf(GetFirstBorhozas);
for i:=1 to TBorthoz(Tennivalo[index]).GetCountBorok do
    begin
    Pince.SearchBor(TDolog(TBorthoz(Tennivalo[index]).GetItemBorok(i-1)).GetFajta).SetMennyiseg(Pince.SearchBor(TDolog(TBorthoz(Tennivalo[index]).GetItemBorok(i-1)).GetFajta).GetMennyiseg - TDolog(TBorthoz(Tennivalo[index]).GetItemBorok(i-1)).GetMennyiseg);
    Uzlet.SearchBor(TDolog(TBorthoz(Tennivalo[index]).GetItemBorok(i-1)).GetFajta).SetMennyiseg(Uzlet.SearchBor(TDolog(TBorthoz(Tennivalo[index]).GetItemBorok(i-1)).GetFajta).GetMennyiseg + TDolog(TBorthoz(Tennivalo[index]).GetItemBorok(i-1)).GetMennyiseg);
    if (Pince.SearchBor(TDolog(TBorthoz(Tennivalo[index]).GetItemBorok(i-1)).GetFajta).GetMennyiseg < 5000) then Pince.SearchBor(TDolog(TBorthoz(Tennivalo[index]).GetItemBorok(i-1)).GetFajta).SetMennyiseg(9999);
    end;
DelTennivalo(index);
Elmegy(Uzlet);
Result := 1;
end;

procedure TBorasz.ClearKiszolgal;
var
  i : Integer;
begin
if (GetCountTennivalo = 0) then Exit;
for i := 1 to GetCountTennivalo do
    begin
    if (Tennivalo[i-1]=nil) then Continue;
    if (TTennivalo(Tennivalo[i-1]).GetFajta = 'Kiszolgls') then
        begin
        Tennivalo[i-1] := nil;
        end;
    end;
Tennivalo.Pack;
end;

procedure TBorasz.Zar;
var
  i : Integer;
begin
if (Uzlet.GetNyitva = True) then
    begin
    for i:=1 to Uzlet.GetCountVendegek do
        begin
        if (Uzlet.GetItemVendegek(i-1)=nil) then Continue;
        TVendeg(Uzlet.GetItemVendegek(i-1)).SetRendelt(0);
        TVendeg(Uzlet.GetItemVendegek(i-1)).Elmegy(Sehol);
        Uzlet.SetItemVendegek(i-1,nil);
        end;
    ClearKiszolgal;
    Uzlet.VendegekPack;
    Uzlet.SetNyitva(False);
    end;
end;

procedure TBorasz.Nyit;
begin
Uzlet.SetNyitva(True);
end;

function TBorasz.Kiszolgal : Integer;
var
  i : Integer;
  j : Integer;
  osszeg : Integer;
  eleg : Boolean;
  kellbor : TBorthoz;
begin
Result := -1;
if (Holvan<>Uzlet) or (GetCountKiszolgalas = 0) then Exit;
for i:=1 to Tennivalo.Count do
    begin
    if (Tennivalo[i-1] = nil) then Continue;
    if (TTennivalo(Tennivalo[i-1]).GetFajta='Kiszolgls') then
        begin
        Result := -2;
        if (Uzlet.IsVendeg(TKiszolgal(Tennivalo[i-1]).GetVendeg) = False) then
            begin
            Tennivalo[i-1]:=nil;
            Continue;
            end;
        osszeg := 0;
        eleg := True;
        for j:=1 to TKiszolgal(Tennivalo[i-1]).GetCountBorok do
            begin
            osszeg := osszeg + TDolog(TKiszolgal(Tennivalo[i-1]).GetItemBorok(j-1)).GetMennyiseg * TDolog(TKiszolgal(Tennivalo[i-1]).GetItemBorok(j-1)).GetAr;
            eleg := eleg and (Uzlet.SearchBor(TDolog(TKiszolgal(Tennivalo[i-1]).GetItemBorok(j-1)).GetFajta).GetMennyiseg > TDolog(TKiszolgal(Tennivalo[i-1]).GetItemBorok(j-1)).GetMennyiseg)
            end;
        Result := 1;
        if (TKiszolgal(Tennivalo[i-1]).GetVendeg.GetPenz < osszeg) or (TKiszolgal(Tennivalo[i-1]).GetVendeg.GetAlkoholszint > 8) then
            begin
            TKiszolgal(Tennivalo[i-1]).GetVendeg.SetRendelt(TKiszolgal(Tennivalo[i-1]).GetVendeg.GetRendelt - 1);
            DelTennivalo(i-1);
            Exit;
            end;
        Result := 2;
        if (eleg = False)
        then
            begin
                if (GetCountBorhozas < 3) then
                    begin
                    kellbor := TBorthoz.Init(1);
                    for j:=1 to Uzlet.GetCountBorok do
                        begin
                        if (TDolog(Uzlet.GetItemBorok(j-1)).GetMennyiseg < 6) then
                             begin
                             kellbor.AddBor(TDolog(Uzlet.GetItemBorok(j-1)).GetFajta,TDolog(Uzlet.GetItemBorok(j-1)).GetEgyseg,20,TDolog(Uzlet.GetItemBorok(j-1)).GetAr);
                             end;
                        end;
                    Tennivalo.Add(kellbor);
                    end;
            TKiszolgal(Tennivalo[i-1]).GetVendeg.SetRendelt(TKiszolgal(Tennivalo[i-1]).GetVendeg.GetRendelt - 1);
            DelTennivalo(i-1);
            Exit;
            end
        else
            begin
            Result := 3;
            TKiszolgal(Tennivalo[i-1]).GetVendeg.SetPenz(TKiszolgal(Tennivalo[i-1]).GetVendeg.GetPenz - osszeg);
            Penz := Penz + osszeg;
            for j:=1 to TKiszolgal(Tennivalo[i-1]).GetCountBorok do
                begin
                Uzlet.SearchBor(TDolog(TKiszolgal(Tennivalo[i-1]).GetItemBorok(j-1)).GetFajta).SetMennyiseg(Uzlet.SearchBor(TDolog(TKiszolgal(Tennivalo[i-1]).GetItemBorok(j-1)).GetFajta).GetMennyiseg - TDolog(TKiszolgal(Tennivalo[i-1]).GetItemBorok(j-1)).GetMennyiseg);
                Uzlet.GetFirstKanna.SetMennyiseg(Uzlet.GetFirstKanna.GetMennyiseg - 1);
                end;
            TKiszolgal(Tennivalo[i-1]).GetVendeg.SetRendelt(TKiszolgal(Tennivalo[i-1]).GetVendeg.GetRendelt - 1);
            DelTennivalo(i-1);
            Exit;          //azert kell hogy csak egyet szolgaljon ki
            end;
        end;
    end;
Tennivalo.Pack;
end;

procedure TBorasz.Leltaraz;
var
  kelle : Boolean;
  i : Integer;
  tempvasar : TVasarol;
  tempbort : TBorthoz;
begin
if (Holvan = Uzlet) then
    begin
    if (GetCountVasarlas < 3) then
      begin
      tempvasar := TVasarol.Init(1);
      kelle := False;
      for i:=1 to Uzlet.GetCountKellekek do
        begin
        if (TDolog(Uzlet.GetItemKellekek(i-1)).GetMennyiseg < 10) then
            begin
            if (TDolog(Uzlet.GetItemKellekek(i-1)).GetFajta = 'Kanna') then tempvasar.AddKellek(TDolog(Uzlet.GetItemKellekek(i-1)).GetFajta,TDolog(Uzlet.GetItemKellekek(i-1)).GetEgyseg,50,TDolog(Uzlet.GetItemKellekek(i-1)).GetAr)
                                                                       else tempvasar.AddKellek(TDolog(Uzlet.GetItemKellekek(i-1)).GetFajta,TDolog(Uzlet.GetItemKellekek(i-1)).GetEgyseg,20,TDolog(Uzlet.GetItemKellekek(i-1)).GetAr);
            kelle := True;
            end;
        end;
      if (kelle = True) then Tennivalo.Add(tempvasar);
      end;
    if (GetCountBorhozas < 3) then
      begin
      tempbort := TBorthoz.Init(1);
      kelle := False;
      for i:=1 to Uzlet.GetCountBorok do
        begin
        if (TDolog(Uzlet.GetItemBorok(i-1)).GetMennyiseg < 6) then
             begin
             tempbort.AddBor(TDolog(Uzlet.GetItemBorok(i-1)).GetFajta,TDolog(Uzlet.GetItemBorok(i-1)).GetEgyseg,20,TDolog(Uzlet.GetItemBorok(i-1)).GetAr);
             kelle := True;
             end;
        end;
      if (kelle = True) then Tennivalo.Add(tempbort);
      end;
    end;
end;

function TBorasz.Elmegy (h : THely) : Integer;
begin
Result := -1;
if (h = Sehol) then Exit;
if (Holvan = Uzlet) and (h <> Uzlet) then Zar;
if (h = Uzlet) then Nyit;
Result := inherited Elmegy(h);
end;

constructor TEllenor.Init (n : String);                           // ELLENOR
begin
inherited Init(n);
Hangulat := 'Htkznapi';
Lepes := 1;
Mehet := True;
end;

function TEllenor.GetHangulat : String;
begin
Result := Hangulat;
end;

function TEllenor.GetMehet : Boolean;
begin
Result := Mehet;
end;

procedure TEllenor.SetMehet(b : Boolean);
begin
Mehet := b;
end;

procedure TEllenor.SetHangulat (h : String);
begin
if (h='Jkedv') or (h='Htkznapi') or (h='Rosszkedv') then Hangulat := h;
end;

procedure TEllenor.Buntet (b : TBorasz; o : Integer);
begin
b.SetPenz(b.GetPenz - o);
if (b.GetPenz<0) then b.SetPenz(0);
if Hangulat='Htkznapi' then Hangulat := 'Jkedv';
if Hangulat='Rosszkedv' then Hangulat := 'Htkznapi';
end;

procedure TEllenor.Jutalmaz (b : TBorasz; o : Integer);
begin
b.SetPenz(b.GetPenz + o);
if Hangulat='Htkznapi' then Hangulat:='Rosszkedv';
if Hangulat='Jkedv' then Hangulat := 'Htkznapi';
end;

procedure TEllenor.Kiurittet (b : TBorasz);
begin
if (Holvan is TUzlet) then
  begin
  b.Zar;
  b.Nyit;
  end;
end;

function TEllenor.Kiir: String;
begin
Result := 'Ez a gonosz TEllenor';
end;

function TEllenor.Vizsgal (b : TBorasz) : Integer;
var
  i : Integer;
  hianyzik : Boolean;
  vanreszeg : Boolean;
begin
Result := -1;
if not (Holvan is TUzlet) then Exit;
hianyzik := False;
vanreszeg := False;
for i:=1 to TUzlet(Holvan).GetCountKellekek do
    begin
    hianyzik := hianyzik or (TDolog(TUzlet(Holvan).GetItemKellekek(i-1)).GetMennyiseg < 3);
    end;
for i:=1 to TUzlet(Holvan).GetCountBorok do
    begin
    hianyzik := hianyzik or (TDolog(TUzlet(Holvan).GetItemBorok(i-1)).GetMennyiseg < 3);
    end;
for i:=1 to TUzlet(Holvan).GetCountVendegek do
    begin
    vanreszeg := vanreszeg or (TVendeg(TUzlet(Holvan).GetItemVendegek(i-1)).GetAlkoholszint > 7);
    end;
if (Hangulat='Jkedv') then
                  begin
                  if (vanreszeg) then begin
                                      if (hianyzik) then begin
                                                         Kiurittet(b);
                                                         Buntet(b,1000);
                                                         Result := 1;
                                                         end
                                                    else begin
                                                         Buntet(b,4500);
                                                         Result := 2;
                                                         end;
                                      end
                                 else begin
                                      if (hianyzik) then begin
                                                         Buntet(b,500);
                                                         Result := 3;
                                                         end
                                                    else begin
                                                         Jutalmaz(b,1500);
                                                         Result := 4;
                                                         end;
                                      end;
                  SetMehet(True);
                  Exit;
                  end;
if (Hangulat='Htkznapi') then
                  begin
                  if (vanreszeg) then begin
                                      if (hianyzik) then begin
                                                         Kiurittet(b);
                                                         Buntet(b,2000);
                                                         Result := 5;
                                                         end
                                                    else begin
                                                         Kiurittet(b);
                                                         Result := 6;                                                       Result := 6;
                                                         end;
                                      end
                                 else begin
                                      if (hianyzik) then begin
                                                         Buntet(b,1500);
                                                         Result := 7;
                                                         end
                                                    else begin
                                                         Jutalmaz(b,1000);
                                                         Result := 8;
                                                         end;
                                      end;
                  SetMehet(True);
                  Exit;
                  end;
if (Hangulat='Rosszkedv') then
                  begin
                  if (vanreszeg) then begin
                                      if (hianyzik) then begin
                                                         Kiurittet(b);
                                                         Buntet(b,3000);
                                                         Result := 9;
                                                         end
                                                    else begin
                                                         Kiurittet(b);
                                                         Result := 10;
                                                         end;
                                      end
                                 else begin
                                      if (hianyzik) then begin
                                                         Buntet(b,2500);
                                                         Result := 11;
                                                         end
                                                    else begin
                                                         Jutalmaz(b,500);
                                                         Result := 12;
                                                         end;
                                      end;
                  SetMehet(True);
                  Exit;
                  end;
end;

function TEllenor.Elmegy (h : THely) : Integer;
begin
Result := -1;
if (h is TUzlet) then
    begin
    if (TUzlet(h).GetNyitva = True) then
        begin
        TUzlet(h).SetVanEllenor(True);
        Result := inherited Elmegy(h);
        end;
    end;
if (h = Sehol) then
    begin
    if not (Holvan is TUzlet) then Exit;
    TUzlet(Holvan).SetVanEllenor(False);
    Result := inherited Elmegy(h);
    end;
end;

constructor TVendeg.Init (n : String);                           // VENDEG
begin
inherited Init(n);
Penz := 0;
Alkoholszint := 0;
Rendelt := -1;
end;

function TVendeg.GetPenz : Integer;
begin
Result := Penz;
end;

function TVendeg.GetAlkoholSzint : Integer;
begin
Result := Alkoholszint;
end;

function TVendeg.GetRendelt : Integer;
begin
Result := Rendelt;
end;

procedure TVendeg.SetRendelt(i : Integer);
begin
if (i<-1) then i:=0;
Rendelt := i;
end;

function TVendeg.Kiir: String;
begin
Result := 'Ez bizony egy TVendeg';
end;

procedure TVendeg.SetPenz (p : Integer);
begin
if (p<0) then p:=0;
if (p>99999) then p:=99999;
Penz := p;
end;

procedure TVendeg.SetAlkoholSzint (a : Integer);
begin
if (a<0) then a:=0;
if (a>10) then a:=10;
Alkoholszint := a;
end;

function TVendeg.Kostol (b : TDolog) : Integer;
var
  uzlet : TUzlet;
  ran : Integer;
begin
Result := -2;
if (not (Holvan is TUzlet)) then Exit;
Randomize;
uzlet := TUzlet(Holvan);
Result := -1;
if (uzlet.SearchBor(b.GetFajta).GetMennyiseg = 0) then Exit;
ran := Random(100);
if (ran<VVSemmi) then Result := 1;
if (ran>=VVSemmi) and (ran<VVSemmi+VVEszik) then
    begin
    uzlet.GetFirstSajt.SetMennyiseg(uzlet.GetFirstSajt.GetMennyiseg - 1);
    Result := 2;
    end;
if (ran>=VVSemmi+VVEszik) and (ran<VVSemmi+VVEszik+VVLeont) then
    begin
    uzlet.GetFirstTerito.SetMennyiseg(uzlet.GetFirstTerito.GetMennyiseg - 1);
    Result := 4;
    end;
if (ran>=VVSemmi+VVEszik+VVLeont) and (ran<=100) then
    begin
    uzlet.GetFirstPohar.SetMennyiseg(uzlet.GetFirstPohar.GetMennyiseg - 1);
    Result := 3;
    end;
SetAlkoholszint(GetAlkoholszint + 1);
end;

function TVendeg.Rendel (b : TEmber) : TTennivalo;
var
  rendeles : TKiszolgal;
  ran1 : Integer;
  ran2 : Integer;
  ran3 : Integer;
  i : Integer;
begin
Result := nil;
if (not (Holvan is TUzlet)) then Exit;
Randomize;
rendeles := TKiszolgal.Init(1);
ran3 := Random(5) + 1;
for i:=1 to ran3 do
    begin
    ran1 := Random(6) + 1;
    ran2 := Random(5) + 1;
    case ran1 of
       1:rendeles.AddBor('Merlot','liter',ran2,BorArMerlot);
       2:rendeles.AddBor('Bikavr','liter',ran2,BorArBikaver);
       3:rendeles.AddBor('Kkfrankos','liter',ran2,BorArKekfrankos);
       4:rendeles.AddBor('Asz','liter',ran2,BorArAszu);
       5:rendeles.AddBor('Olaszrizling','liter',ran2,BorArOlaszrizling);
       6:rendeles.AddBor('Szamorodni','liter',ran2,BorArSzamorodni);
    end;
    end;
rendeles.SetVendeg(Self);
TBorasz(b).AddTennivalo(rendeles);
Result := rendeles;
end;

function TVendeg.Elmegy (h : THely) : Integer;
begin
Result := -1;
if (h is TUzlet) then
    begin
    if (TUzlet(h).GetNyitva = True) then
        begin
        TUzlet(h).AddVendeg(Self);
        Result := inherited Elmegy(h);
        Exit;
        end
    else
        begin
        Exit;
        end
    end
else
    begin
    if (h = Sehol) then
        begin
        Rendelt := -1;
        Penz := Penz + VendegPremium;
        if (Alkoholszint > 0) then Alkoholszint := Alkoholszint - AlkMinus;
        if (Alkoholszint < 0) then Alkoholszint := 0;
        Result := inherited Elmegy(h);
        end
    else
        begin
        Exit;
        end
    end;
end;

constructor TPince.Init (n : String; ny : Boolean);        // PINCE
begin
inherited Init(n,ny);
Borok := TList.Create;
Borok.Capacity := BorokSzama;
end;

destructor TPince.Destroy;
begin
Borok.Free;
end;

function TPince.GetCountBorok : Integer;
begin
Result := Borok.Count;
end;

function TPince.GetItemBorok (i : Integer) : Pointer;
begin
Result := Borok[i];
end;

function TPince.SearchBor (b : String) : TDolog;
var
  i : Integer;
begin
for i:=1 to Borok.Count do
    begin
    if (Borok[i-1]=nil) then Continue;
    if (TDolog(Borok[i-1]).GetFajta=b) then
        begin
        Result:=TDolog(Borok[i-1]);
        Exit;
        end;
    end;
Result:=nil;
end;

procedure TPince.AddBor(f,e : String; m,a : Integer);
var
  b : TDolog;
begin
b := TDolog.Init(f,e,m,a);
Borok.Add(b);
end;

procedure TPince.DelBor (i : Integer);
begin
Borok[i] := nil;
Borok.Pack;
end;

constructor TUzlet.Init (n : String; ny : Boolean);        // UZLET
begin
inherited Init(n,ny);
Vendegek := TList.Create;
Borok := TList.Create;
Kellekek := TList.Create;
Vendegek.Capacity := VendegekSzama;
Borok.Capacity := BorokSzama;
Kellekek.Capacity := KellekekSzama;
end;

destructor TUzlet.Destroy;
begin
Vendegek.Free;
Borok.Free;
Kellekek.Free;
end;

function TUzlet.IsKellek (d : TDolog) : Boolean;
begin
if (Kellekek.IndexOf(d) = -1) then Result := False
                              else Result := True;
end;

function TUzlet.SearchKellek (d : TDolog) : Integer;
begin
Result := Kellekek.IndexOf(d);
end;

function TUzlet.SearchKellek (s : String) : Pointer;
var
  i : Integer;
begin
Result := nil;
for i:=1 to Kellekek.Count do
    begin
    if (Kellekek[i-1]=nil) then Continue;
    if (TDolog(Kellekek[i-1]).GetFajta = s) then
        begin
        Result := TDolog(Kellekek[i-1]);
        Exit;
        end;
    end;
end;

procedure TUzlet.SetVanEllenor(b : Boolean);
begin
VanEllenor := b;
end;

function TUzlet.GetVanEllenor : Boolean;
begin
Result := VanEllenor;
end;

function TUzlet.GetCountKanna : Integer;
var
  i : Integer;
begin
Result := 0;
for i:=1 to Kellekek.Count do
    begin
    if (Kellekek[i-1]=nil) then Continue;
    if (TDolog(Kellekek[i-1]).GetFajta = 'Kanna') then Result := Result + 1;
    end;
end;

function TUzlet.GetCountSajt : Integer;
var
  i : Integer;
begin
Result := 0;
for i:=1 to Kellekek.Count do
    begin
    if (Kellekek[i-1]=nil) then Continue;
    if (TDolog(Kellekek[i-1]).GetFajta = 'Sajt') then Result := Result + 1;
    end;
end;

function TUzlet.GetCountTerito : Integer;
var
  i : Integer;
begin
Result := 0;
for i:=1 to Kellekek.Count do
    begin
    if (Kellekek[i-1]=nil) then Continue;
    if (TDolog(Kellekek[i-1]).GetFajta = 'Tert') then Result := Result + 1;
    end;
end;

function TUzlet.GetCountPohar : Integer;
var
  i : Integer;
begin
Result := 0;
for i:=1 to Kellekek.Count do
    begin
    if (Kellekek[i-1]=nil) then Continue;
    if (TDolog(Kellekek[i-1]).GetFajta = 'Pohr') then Result := Result + 1;
    end;
end;

function TUzlet.GetFirstKanna : TDolog;
var
  i : Integer;
begin
Result := nil;
if (GetCountKanna<>0) then
    begin
    for i:=1 to Kellekek.Count do
        begin
        if (Kellekek[i-1]=nil) then Continue;
        if (TDolog(Kellekek[i-1]).GetFajta = 'Kanna') then
            begin
            Result := TDolog(Kellekek[i-1]);
            Exit;
            end;
        end;
    end;
end;

function TUzlet.GetFirstSajt : TDolog;
var
  i : Integer;
begin
Result := nil;
if (GetCountSajt<>0) then
    begin
    for i:=1 to Kellekek.Count do
        begin
        if (Kellekek[i-1]=nil) then Continue;
        if (TDolog(Kellekek[i-1]).GetFajta = 'Sajt') then
            begin
            Result := TDolog(Kellekek[i-1]);
            Exit;
            end;
        end;
    end;
end;

function TUzlet.GetFirstTerito : TDolog;
var
  i : Integer;
begin
Result := nil;
if (GetCountTerito<>0) then
    begin
    for i:=1 to Kellekek.Count do
        begin
        if (Kellekek[i-1]=nil) then Continue;
        if (TDolog(Kellekek[i-1]).GetFajta = 'Tert') then
            begin
            Result := TDolog(Kellekek[i-1]);
            Exit;
            end;
        end;
    end;
end;

function TUzlet.GetFirstPohar : TDolog;
var
  i : Integer;
begin
Result := nil;
if (GetCountPohar<>0) then
    begin
    for i:=1 to Kellekek.Count do
        begin
        if (Kellekek[i-1]=nil) then Continue;
        if (TDolog(Kellekek[i-1]).GetFajta = 'Pohr') then
            begin
            Result := TDolog(Kellekek[i-1]);
            Exit;
            end;
        end;
    end;
end;

procedure TUzlet.AddKellek (f,e : String; m,a : Integer);
var
  k : TDolog;
begin
k := TDolog.Init(f,e,m,a);
Kellekek.Add(k);
end;

procedure TUzlet.DelKellek (i : Integer);
begin
Kellekek[i] := nil;
Kellekek.Pack;
end;

function TUzlet.SearchBor (b : String) : TDolog;
var
  i : Integer;
begin
for i:=1 to Borok.Count do
    begin
    if (Borok[i-1]=nil) then Continue;
    if (TDolog(Borok[i-1]).GetFajta=b) then
        begin
        Result:=TDolog(Borok[i-1]);
        Exit;
        end;
    end;
Result:=nil;
end;

procedure TUzlet.AddBor (f,e : String; m,a : Integer);
var
  b : TDolog;
begin
b := TDolog.Init(f,e,m,a);
Borok.Add(b);
end;

procedure TUzlet.DelBor (i : Integer);
begin
Borok[i] := nil;
Borok.Pack;
end;

function TUzlet.IsVendeg (v : TVendeg) : Boolean;
begin
if (Vendegek.IndexOf(v)=-1) then Result:=False
                            else Result:=True;
end;

function TUzlet.SearchVendeg (v : TVendeg) : Integer;
begin
Result := Vendegek.IndexOf(v);
end;

function TUzlet.SearchVendeg (s : String) : Integer;
var
  i : Integer;
begin
Result := -1;
for i:=1 to Vendegek.Count do
    begin
    if (TVendeg(Vendegek[i-1]) = nil) then Continue;
    if (TVendeg(Vendegek[i-1]).GetNev = s) then
        begin
        Result := i-1;
        Exit;
        end;
    end;
end;

procedure TUzlet.AddVendeg(v : TVendeg);
begin
if (Vendegek.IndexOf(v) = -1) then Vendegek.Add(v);
end;

procedure TUzlet.DelVendeg(i : Integer);
begin
Vendegek[i] := nil;
Vendegek.Pack;
end;

function TUzlet.GetCountVendegek : Integer;
begin
Result := Vendegek.Count;
end;

function TUzlet.GetCountBorok : Integer;
begin
Result := Borok.Count;
end;

function TUzlet.GetCountKellekek : Integer;
begin
Result := Kellekek.Count;
end;

function TUzlet.GetItemVendegek(i : Integer) : Pointer;
begin
Result := Vendegek[i];
end;

procedure TUzlet.SetItemVendegek (i : Integer; p : Pointer);
begin
Vendegek.Items[i] := p;
end;

procedure TUzlet.VendegekPack;
begin
Vendegek.Pack;
end;

function TUzlet.GetItemBorok(i : Integer) : Pointer;
begin
Result := Borok[i];
end;

function TUzlet.GetItemKellekek(i : Integer) : Pointer;
begin
Result := Kellekek[i];
end;

constructor TSzakbolt.Init (n : String; ny : Boolean);      // SZAKBOLT
begin
inherited Init(n,ny);
Kellekek := TList.Create;
Kellekek.Capacity := KellekekSzama;
end;

destructor TSzakbolt.Destroy;
begin
Kellekek.Free;
end;

function TSzakbolt.GetCountKellekek : Integer;
begin
Result := Kellekek.Count;
end;

function TSzakbolt.GetItemKellekek (i : Integer) : Pointer;
begin
Result := Kellekek[i];
end;

function TSzakbolt.IsKellek (d : TDolog) : Boolean;
begin
if (Kellekek.IndexOf(d) = -1) then Result := False
                              else Result := True;
end;

function TSzakbolt.SearchKellek (d : TDolog) : Integer;
begin
Result := Kellekek.IndexOf(d);
end;

function TSzakbolt.SearchKellek (s : String) : Pointer;
var
  i : Integer;
begin
Result := nil;
for i:=1 to Kellekek.Count do
    begin
    if (Kellekek[i-1]=nil) then Continue;
    if (TDolog(Kellekek[i-1]).GetFajta = s) then
        begin
        Result:=TDolog(Kellekek[i-1]);
        Exit;
        end;
    end;
end;

function TSzakbolt.GetCountKanna : Integer;
var
  i : Integer;
begin
Result := 0;
for i:=1 to Kellekek.Count do
    begin
    if (Kellekek[i-1]=nil) then Continue;
    if (TDolog(Kellekek[i-1]).GetFajta = 'Kanna') then Result := Result + 1;
    end;
end;

function TSzakbolt.GetCountSajt : Integer;
var
  i : Integer;
begin
Result := 0;
for i:=1 to Kellekek.Count do
    begin
    if (Kellekek[i-1]=nil) then Continue;
    if (TDolog(Kellekek[i-1]).GetFajta = 'Sajt') then Result := Result + 1;
    end;
end;

function TSzakbolt.GetCountTerito : Integer;
var
  i : Integer;
begin
Result := 0;
for i:=1 to Kellekek.Count do
    begin
    if (Kellekek[i-1]=nil) then Continue;
    if (TDolog(Kellekek[i-1]).GetFajta = 'Tert') then Result := Result + 1;
    end;
end;

function TSzakbolt.GetCountPohar : Integer;
var
  i : Integer;
begin
Result := 0;
for i:=1 to Kellekek.Count do
    begin
    if (Kellekek[i-1]=nil) then Continue;
    if (TDolog(Kellekek[i-1]).GetFajta = 'Pohr') then Result := Result + 1;
    end;
end;

function TSzakbolt.GetFirstKanna : TDolog;
var
  i : Integer;
begin
Result := nil;
if (GetCountKanna<>0) then
    begin
    for i:=1 to Kellekek.Count do
        begin
        if (Kellekek[i-1]=nil) then Continue;
        if (TDolog(Kellekek[i-1]).GetFajta = 'Kanna') then
            begin
            Result := TDolog(Kellekek[i-1]);
            Exit;
            end;
        end;
    end;
end;

function TSzakbolt.GetFirstSajt : TDolog;
var
  i : Integer;
begin
Result := nil;
if (GetCountSajt<>0) then
    begin
    for i:=1 to Kellekek.Count do
        begin
        if (Kellekek[i-1]=nil) then Continue;
        if (TDolog(Kellekek[i-1]).GetFajta = 'Sajt') then
            begin
            Result := TDolog(Kellekek[i-1]);
            Exit;
            end;
        end;
    end;
end;

function TSzakbolt.GetFirstTerito : TDolog;
var
  i : Integer;
begin
Result := nil;
if (GetCountTerito<>0) then
    begin
    for i:=1 to Kellekek.Count do
        begin
        if (Kellekek[i-1]=nil) then Continue;
        if (TDolog(Kellekek[i-1]).GetFajta = 'Tert') then
            begin
            Result := TDolog(Kellekek[i-1]);
            Exit;
            end;
        end;
    end;
end;

function TSzakbolt.GetFirstPohar : TDolog;
var
  i : Integer;
begin
Result := nil;
if (GetCountPohar<>0) then
    begin
    for i:=1 to Kellekek.Count do
        begin
        if (Kellekek[i-1]=nil) then Continue;
        if (TDolog(Kellekek[i-1]).GetFajta = 'Pohr') then
            begin
            Result := TDolog(Kellekek[i-1]);
            Exit;
            end;
        end;
    end;
end;

procedure TSzakbolt.AddKellek (f,e : String; m,a : Integer);
var
  k : TDolog;
begin
k := TDolog.Init(f,e,m,a);
Kellekek.Add(k);
end;

procedure TSzakbolt.DelKellek (i : Integer);
begin
Kellekek[i] := nil;
Kellekek.Pack;
end;

constructor TBorthoz.Init (i : Integer);                              // BORTHOZ
begin
inherited Init(i);
Fajta := 'Borhozs';
Borok := TList.Create;
Borok.Capacity := BorokSzama;
end;

destructor TBorthoz.Destroy;
begin
Borok.Free;
end;

function TBorthoz.GetCountBorok : Integer;
begin
Result := Borok.Count;
end;

function TBorthoz.GetItemBorok (i : Integer) : Pointer;
begin
Result := Borok[i];
end;

function TBorthoz.SearchBor (b : String) : TDolog;
var
  i : Integer;
begin
Result := nil;
for i:=1 to Borok.Count do
    begin
    if (Borok[i-1]=nil) then Continue;
    if (TDolog(Borok[i-1]).GetFajta = b) then
        begin
        Result:=TDolog(Borok[i-1]);
        Exit;
        end;
    end;
end;

procedure TBorthoz.AddBor (f,e : String; m,a : Integer);
var
  b : TDolog;
begin
b := TDolog.Init(f,e,m,a);
Borok.Add(b);
end;

procedure TBorthoz.DelBor (i : Integer);
begin
Borok[i] := nil;
Borok.Pack;
end;

constructor TVasarol.Init (i : Integer);                        // VASAROL
begin
inherited Init(i);
Fajta := 'Vsrls';
Kellekek := TList.Create;
Kellekek.Capacity := KellekekSzama;
end;

destructor TVasarol.Destroy;
begin
Kellekek.Free;
end;

function TVasarol.GetCountKellekek : Integer;
begin
Result := Kellekek.Count;
end;

function TVasarol.GetItemKellekek(i : Integer) : Pointer;
begin
Result := Kellekek[i];
end;

function TVasarol.SearchKellek(k : String) : TDolog;
var
  i : Integer;
begin
for i:=1 to Kellekek.Count do
    begin
    if (Kellekek[i-1]=nil) then Continue;
    if (TDolog(Kellekek[i-1]).GetFajta=k) then
        begin
        Result:=TDolog(Kellekek[i-1]);
        Exit;
        end;
    end;
Result:=nil;
end;

procedure TVasarol.AddKellek (f,e : String; m,a : Integer);
var
  k : TDolog;
begin
k := TDolog.Init(f,e,m,a);
Kellekek.Add(k);
end;

procedure TVasarol.DelKellek (i : Integer);
begin
Kellekek[i] := nil;
Kellekek.Pack;
end;

constructor TKiszolgal.Init (i: Integer);                        // KISZOLGAL
begin
inherited Init(i);
Fajta := 'Kiszolgls';
Vendeg := nil;
Borok := TList.Create;
Borok.Capacity := BorokSzama;
end;

destructor TKiszolgal.Destroy;
begin
Borok.Free;
end;

function TKiszolgal.GetVendeg : TVendeg;
begin
Result := Vendeg;
end;

procedure TKiszolgal.SetVendeg (v : TVendeg);
begin
Vendeg := v;
end;

function TKiszolgal.GetCountBorok : Integer;
begin
Result := Borok.Count;
end;

function TKiszolgal.GetItemBorok(i : Integer) : Pointer;
begin
Result := Borok[i];
end;

function TKiszolgal.SearchBor (b : String) : TDolog;
var
  i : Integer;
begin
for i:=1 to Borok.Count do
    begin
    if (Borok[i-1]=nil) then Continue;
    if (TDolog(Borok[i-1]).GetFajta=b) then
        begin
        Result:=TDolog(Borok[i-1]);
        Exit;
        end;
    end;
Result:=nil;
end;

procedure TKiszolgal.AddBor(f,e : String; m,a : Integer);
var
  b : TDolog;
begin
b := TDolog.Init(f,e,m,a);
Borok.Add(b);
end;

procedure TKiszolgal.DelBor (i : Integer);
begin
Borok[i] := nil;
Borok.Pack;
end;


end.
