unit BoraszForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus, Buttons, SetupForm, BoraszClasses,
  TennivaloForm, DologForm, VendegForm, EllenForm, Hh, Hh_Funcs, ShellApi,
  ComCtrls;

type
  TFoAblak = class(TForm)
    lbEvents: TListBox;
    FoMenu: TMainMenu;
    Sim: TMenuItem;
    Info: TMenuItem;
    Start: TMenuItem;
    Stop: TMenuItem;
    Exit: TMenuItem;
    Setup: TMenuItem;
    BtnExit: TBitBtn;
    BtnStop: TBitBtn;
    BtnStart: TBitBtn;
    BtnStep: TBitBtn;
    Step: TMenuItem;
    BtnSetup: TBitBtn;
    Bevel1: TBevel;
    StaticText1: TStaticText;
    StaticText3: TStaticText;
    StaticText5: TStaticText;
    StaticText7: TStaticText;
    StaticText13: TStaticText;
    stBNev: TStaticText;
    stBHolvan: TStaticText;
    stBPenz: TStaticText;
    lbTennivalok: TListBox;
    Bevel2: TBevel;
    StaticText2: TStaticText;
    StaticText4: TStaticText;
    StaticText6: TStaticText;
    StaticText10: TStaticText;
    StaticText11: TStaticText;
    StaticText12: TStaticText;
    stUNev: TStaticText;
    stUNyitva: TStaticText;
    lbKellekek: TListBox;
    lbBorok: TListBox;
    lbVendegek: TListBox;
    StaticText14: TStaticText;
    stEllenor: TStaticText;
    Label1: TLabel;
    StaticText8: TStaticText;
    stBCsinal: TStaticText;
    StaticText9: TStaticText;
    stUvszam: TStaticText;
    stBLepes: TStaticText;
    artalom1: TMenuItem;
    Program1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    sbMain: TStatusBar;
    procedure BtnStartClick(Sender: TObject);
    procedure BtnStopClick(Sender: TObject);
    procedure BtnExitClick(Sender: TObject);
    procedure BtnStepClick(Sender: TObject);
    procedure BtnSetupClick(Sender: TObject);
    procedure lbTennivalokMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lbBorokMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lbKellekekMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lbVendegekMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure artalom1Click(Sender: TObject);
    procedure Program1Click(Sender: TObject);
  private
    procedure DisplayHint(Sender: TObject);
  public
    procedure Permutate;
    procedure InfoUpdate;
    procedure InfoClear;
    procedure Write (s : String);
    procedure AuditUpdate;
    procedure SetIdok (b : TBorasz);
    procedure Leltaraz (b : TBorasz);
    procedure Kiszolgal (b : TBorasz);
    procedure Borthoz (b : TBorasz);
    procedure Vasarol (b : TBorasz);
    procedure Allapot(all: String);
//    procedure VmitKiir (e : TEmber);    // dinamikus kotes kedveert
  end;

var
  FoAblak: TFoAblak;
  FoBorasz : TBorasz;
  Borozo : TUzlet;
  Szakbolt : TSzakbolt;
  Pince : TPince;
  Ellenor : TEllenor;
  Vendegek : TList;
//  Ember : TEmber;            //dinamikus kotes kedveert
  check : TBitmap;
  undo : TBitmap;
  tmpbool : Boolean;
  mHHelp: THookHelpSystem;

implementation

{$R *.dfm}

procedure TFoAblak.Permutate;
var
  i : Integer;
  ran1 ,ran2 : Integer;
begin
Randomize;
for i:=1 to 10 do
    begin
    ran1 := Random(5)+1;
    ran2 := Random(5)+1;
    Vendegek.Exchange(ran1,ran2);
    end;
end;

procedure TFoAblak.BtnStartClick(Sender: TObject);
var
  i : Integer;
begin
Allapot('Folyamatban...');
DoItForm.Clear;
GuestForm.Clear;
ThingForm.Clear;
tmpbool := False;
lbEvents.Clear;
Sehol := THely.Init('Seholsem',True);
Vendegek := TList.Create;
Vendegek.Capacity := 6;

FoBorasz := TBorasz.Init(SetupAblak.ebBNev.Text);
Borozo := TUzlet.Init(SetupAblak.ebUNev.Text,False);
Szakbolt := TSzakbolt.Init(SetupAblak.ebSzNev.Text,True);
Pince := TPince.Init(SetupAblak.ebPNev.Text,True);
Ellenor := TEllenor.Init(SetupAblak.ebENev.Text);

Vendegek.Add(TVendeg.Init('borszakrt'));
Vendegek.Add(TVendeg.Init('vendgmunks'));
Vendegek.Add(TVendeg.Init('szegedi tanr'));
Vendegek.Add(TVendeg.Init('tokaji borszkollga'));
Vendegek.Add(TVendeg.Init('klfldi turista'));
Vendegek.Add(TVendeg.Init('krnykbeli bcsi'));
Permutate;

for i:=1 to (6 - StrToInt(SetupAblak.ebVSzam.Text)) do
    begin
    Vendegek[StrToInt(SetupAblak.ebVSzam.Text)+i-1] := nil;
    end;
Vendegek.Pack;
Vendegek.Capacity := StrToInt(SetupAblak.ebVSzam.Text);
for i:=1 to StrToInt(SetupAblak.ebVSzam.Text) do
    begin
    TVendeg(Vendegek[i-1]).SetPenz(StrToInt(SetupAblak.ebVPenz.Text));
    end;

FoBorasz.SetUzlet(Borozo);
FoBorasz.SetSzakbolt(Szakbolt);
FoBorasz.SetPince(Pince);
FoBorasz.Elmegy(Borozo);
FoBorasz.SetPenz(StrToInt(SetupAblak.ebBPenz.Text));

Ellenor.SetHangulat(SetupAblak.cbEHangulat.Text);

Borozo.AddKellek('Kanna','darab',0,KellekArKanna);
Borozo.AddKellek('Sajt','kil',0,KellekArSajt);
Borozo.AddKellek('Pohr','darab',0,KellekArPohar);
Borozo.AddKellek('Tert','darab',0,KellekArTerito);
Borozo.AddBor('Merlot','liter',0,BorArMerlot);
Borozo.AddBor('Bikavr','liter',0,BorArBikaver);
Borozo.AddBor('Kkfrankos','liter',0,BorArKekfrankos);
Borozo.AddBor('Asz','liter',0,BorArAszu);
Borozo.AddBor('Olaszrizling','liter',0,BorArOlaszrizling);
Borozo.AddBor('Szamorodni','liter',0,BorArSzamorodni);

Szakbolt.AddKellek('Kanna','darab',9999,KellekArKanna);
Szakbolt.AddKellek('Sajt','kil',9999,KellekArSajt);
Szakbolt.AddKellek('Pohr','darab',9999,KellekArPohar);
Szakbolt.AddKellek('Tert','darab',9999,KellekArTerito);

Pince.AddBor('Merlot','liter',9999,BorArMerlot);
Pince.AddBor('Bikavr','liter',9999,BorArBikaver);
Pince.AddBor('Kkfrankos','liter',9999,BorArKekfrankos);
Pince.AddBor('Asz','liter',9999,BorArAszu);
Pince.AddBor('Olaszrizling','liter',9999,BorArOlaszrizling);
Pince.AddBor('Szamorodni','liter',9999,BorArSzamorodni);
{
//DINAMIKUS KOTES SZEMLELTETESE   BEGIN                             *********************
Ember := TEmber.Init('sember');
VmitKiir(Ember);
VmitKiir(FoBorasz);
VmitKiir(Ellenor);
VmitKiir(Vendegek[0]);         //elszallhat ha nincs vendeg
//DINAMIKUS KOTES SZEMLELTETESE   END                               *********************
}
InfoUpdate;
BtnStart.Visible := False;
FoMenu.Items[0].Items[0].Enabled := False;
BtnSetup.Visible := False;
FoMenu.Items[0].Items[3].Enabled := False;
BtnStep.Visible := True;
FoMenu.Items[0].Items[1].Enabled := True;
BtnExit.Visible := False;
FoMenu.Items[0].Items[6].Enabled := False;
BtnStop.Visible := True;
FoMenu.Items[0].Items[5].Enabled := True;
BtnStep.SetFocus;
Label1.Enabled := True;
StaticText1.Enabled := True;
StaticText2.Enabled := True;
StaticText3.Enabled := True;
StaticText4.Enabled := True;
StaticText5.Enabled := True;
StaticText6.Enabled := True;
StaticText7.Enabled := True;
StaticText8.Enabled := True;
StaticText9.Enabled := True;
StaticText10.Enabled := True;
StaticText11.Enabled := True;
StaticText12.Enabled := True;
StaticText13.Enabled := True;
StaticText14.Enabled := True;

Write('-B- >> dvzlm! '+ FoBorasz.GetNev +' vagyok, az n borsza...');
Write('-B- >> Lssunk ht munkhoz!');
FoBorasz.Leltaraz;
end;

procedure TFoAblak.InfoUpdate;
var
  i : Integer;
begin
InfoClear;
stBNev.Caption := FoBorasz.GetNev;
stBHolvan.Caption := FoBorasz.GetHolvan.GetNev;
stBPenz.Caption := IntToStr(FoBorasz.GetPenz);
for i:=1 to FoBorasz.GetCountTennivalo do
    begin
    if (FoBorasz.GetItemTennivalo(i-1)=nil) then Continue;
    lbTennivalok.AddItem(TTennivalo(FoBorasz.GetItemTennivalo(i-1)).GetFajta,nil);
    end;
stUNev.Caption := Borozo.GetNev;
stUvszam.Caption := SetupAblak.ebVSzam.Text;
case FoBorasz.GetMitCsinal of
    0: stBCsinal.Caption := 'Pihizik...';
    1: stBCsinal.Caption := 'Leltraz...';
    2: stBCsinal.Caption := 'Kiszolgl...';
    3: stBCsinal.Caption := 'Borthoz...';
    4: stBCsinal.Caption := 'Vsrol...';
else   stBCsinal.Caption := '-ERROR- Rosszalkodik! :o)';
end;
if (FoBorasz.GetIdo<>0) then stBLepes.Caption := 'mg '+ IntToStr(FoBorasz.GetIdo) +' lpsig'
                        else stBLepes.Caption := '';

if (Borozo.GetNyitva = True) then stUNyitva.Caption := 'Nyitva'
                             else stUNyitva.Caption := 'Zrva';
if (Borozo.GetVanEllenor = True) then stEllenor.Caption := 'zletben van'
                                 else stEllenor.Caption := 'Sehol senki';
for i:=1 to Borozo.GetCountVendegek do
    begin
    if (Borozo.GetItemVendegek(i-1)=nil) then Continue;
    case (TVendeg(Borozo.GetItemVendegek(i-1)).GetRendelt) of
    -1:  lbVendegek.AddItem(TVendeg(Borozo.GetItemVendegek(i-1)).GetNev + '  kstolgat',nil);
     0:  lbVendegek.AddItem(TVendeg(Borozo.GetItemVendegek(i-1)).GetNev + '  tvozban',nil);
    else lbVendegek.AddItem(TVendeg(Borozo.GetItemVendegek(i-1)).GetNev + '  '+IntToStr(TVendeg(Borozo.GetItemVendegek(i-1)).GetRendelt) + ' rendels',nil);
    end;
    end;
for i:=1 to Borozo.GetCountBorok do
    begin
    if (Borozo.GetItemBorok(i-1)=nil) then Continue;
    if (TDolog(Borozo.GetItemBorok(i-1)).GetMennyiseg = 0) then lbBorok.AddItem(DoitForm.BorRag(TDolog(Borozo.GetItemBorok(i-1)).GetFajta) + '  Nincs', nil)
                                                           else lbBorok.AddItem(DoitForm.BorRag(TDolog(Borozo.GetItemBorok(i-1)).GetFajta) + IntToStr(TDolog(Borozo.GetItemBorok(i-1)).GetMennyiseg) + ' ' + TDolog(Borozo.GetItemBorok(i-1)).GetEgyseg, nil);
    end;
for i:=1 to Borozo.GetCountKellekek do
    begin
    if (Borozo.GetItemKellekek(i-1)=nil) then Continue;
    if (TDolog(Borozo.GetItemKellekek(i-1)).GetMennyiseg = 0) then lbKellekek.AddItem(DoitForm.KellekRag(TDolog(Borozo.GetItemKellekek(i-1)).GetFajta) + '     Nincs', nil)
                                                              else lbKellekek.AddItem(DoitForm.KellekRag(TDolog(Borozo.GetItemKellekek(i-1)).GetFajta) + IntToStr(TDolog(Borozo.GetItemKellekek(i-1)).GetMennyiseg) + ' ' + TDolog(Borozo.GetItemKellekek(i-1)).GetEgyseg, nil);
    end;
DoitForm.InfoCheck(FoBorasz);
DoitForm.InfoUpdate;
GuestForm.InfoUpdate;
ThingForm.InfoUpdate;
AuditUpdate;
end;

procedure TFoAblak.InfoClear;
begin
stBNev.Caption := '';
stBHolvan.Caption := '';
stBPenz.Caption := '';
stBCsinal.Caption := '';
lbTennivalok.Clear;
stUNev.Caption := '';
stUNyitva.Caption := '';
stEllenor.Caption := '';
stUVszam.Caption := '';
stBLepes.Caption := '';
lbVendegek.Clear;
lbBorok.Clear;
lbKellekek.Clear;
end;

procedure TFoAblak.BtnStopClick(Sender: TObject);
begin
DoitForm.Clear;
DoitForm.Close;
ThingForm.Clear;
ThingForm.Close;
GuestForm.Clear;
GuestForm.Close;
AuditForm.Clear;
AuditForm.Close;

Write('-B- >> Borban az igazsg! Viszlt!');
FoBorasz.Free;
Borozo.Free;
Szakbolt.Free;
Pince.Free;
Ellenor.Free;
Sehol.Free;
Vendegek.Free;

InfoClear;
BtnStop.Visible := False;
FoMenu.Items[0].Items[5].Enabled := False;
BtnStep.Visible := False;
FoMenu.Items[0].Items[1].Enabled := False;
BtnStart.Visible := True;
FoMenu.Items[0].Items[0].Enabled := True;
BtnSetup.Visible := True;
FoMenu.Items[0].Items[3].Enabled := True;
BtnExit.Visible := True;
FoMenu.Items[0].Items[6].Enabled := True;
Label1.Enabled := False;
StaticText1.Enabled := False;
StaticText2.Enabled := False;
StaticText3.Enabled := False;
StaticText4.Enabled := False;
StaticText5.Enabled := False;
StaticText6.Enabled := False;
StaticText7.Enabled := False;
StaticText8.Enabled := False;
StaticText9.Enabled := False;
StaticText10.Enabled := False;
StaticText11.Enabled := False;
StaticText12.Enabled := False;
StaticText13.Enabled := False;
StaticText14.Enabled := False;
Allapot('Lelltva...');
end;

procedure TFoAblak.BtnExitClick(Sender: TObject);
begin
Allapot('Kilps...');
FoAblak.Close;
end;

procedure TFoAblak.BtnStepClick(Sender: TObject);
var
  i, j : Integer;
  ran, tmp : Integer;
  bor : Integer;
  rendeles : TKiszolgal;
begin
Allapot('Lptets...');
Write(' ');
Randomize;
ran := Random(100);
FoBorasz.DecIdo(1);
if (FoBorasz.GetIdo = 0) then
    begin
    if (FoBorasz.GetMitCsinal = 0) then
        begin
        end;
    if (FoBorasz.GetMitCsinal = 1) then
        begin
        FoBorasz.Leltaraz;
        SetIdok(FoBorasz);
        FoBorasz.SetMitCsinal(0);
        end;
    if (FoBorasz.GetMitCsinal = 2) then
        begin
        tmp := FoBorasz.Kiszolgal;
        case tmp of
            -1: begin
                end;
            -2: begin
                Write('-B-ERROR >> Furcsamd csak olyan rendelseket talltam, amelyekhez mr nincs itt a vendg.');
                end;
             1: begin
                Write('-B- >> Rszegeket nem szolglunk ki! Ha pedig nem vagy rszeg, legyen elg pnzed! Nnna kifel! :o)');
                end;
             2: begin
                Write('-B- >> Sajnos nincs elg bor a raktron! Ideje lenne elmennem a pincmbe...');
                end;
             3: begin
                Write('-B- >> Vljk egszsgre! Ksznm a vsrlst!');
                end;
        else    Write('-B-ERROR >> Valami nagyon elszllt kiszolgls kzben!');
        end;
        SetIdok(FoBorasz);
        FoBorasz.SetMitCsinal(0);
        end;
    if (FoBorasz.GetMitCsinal = 3) then
        begin
        tmp := FoBorasz.Borthoz;
        case tmp of
            -1: begin
                end;
            -2: begin
                Write('-B-ERROR >> Furcsamd res borhozs kerlt a tennivallistba!');
                end;
             1: begin
                Write('-B- >> Hoztam egy nagy adag bort a pincmbl! Ez elg lesz egy ideig.');
                end;
        else    Write('-B-ERROR >> Valami nagyon elszllt borhozs kzben!');
        end;
        FoBorasz.SetMitCsinal(0);
        end;
    if (FoBorasz.GetMitCsinal = 4) then
        begin
        tmp := FoBorasz.Vasarol;
        case tmp of
            -1: begin
                end;
            -2: begin
                Write('-B-ERROR >> Furcsamd res vsrls kerlt a tennivallistba!');
                end;
             1: begin
                Write('-B- >> Vsroltam amit kellett. Amennyire a pnzembl futotta.');
                end;
        else    Write('-B-ERROR >> Valami nagyon elszllt vsrls kzben!');
        end;
        FoBorasz.SetMitCsinal(0);
        end;
    if (Borozo.GetCountVendegek < 2) then
       begin
       if (ran < BVBorthoz) then
           begin
           if (FoBorasz.GetCountBorhozas <> 0) and (Borozo.GetVanEllenor = False) then Borthoz(FoBorasz);
           end;
       if (ran > BVBorthoz) and (ran < BVBorthoz + BVVasarol) then
           begin
           if (FoBorasz.GetCountVasarlas <> 0) and (Borozo.GetVanEllenor = False) then Vasarol(FoBorasz);
           end;
       end;
    end;

if (FoBorasz.GetPenz >= 500000) then
  begin
  MessageDlg('JMI?! Addig nyomtad az entert amg a borsz meg nem gazdagodott. Prbld ki a programot ms belltsokkal is... Ennek a jtknak most vge!', mtInformation,[mbOk],0);
  FoAblak.BtnStopClick(FoAblak);
  System.Exit;
  end;

                                                      // VENDEGLEPES

for i:=1 to Vendegek.Count do
    begin
    ran := Random(100);                       // a vendeg erkezik VVErkezik valoszinuseggel
    if (TVendeg(Vendegek[i-1]).GetHolvan = Sehol) and (ran < VVErkezik) then
        begin
        tmp:=TVendeg(Vendegek[i-1]).Elmegy(Borozo);
        case tmp of
            -1: Write('-V- >> ['+TVendeg(Vendegek[i-1]).GetNev+'] >> Zrva talltam a borozt...');
             0: Write('-V-ERROR >> ['+TVendeg(Vendegek[i-1]).GetNev+'] >> Mr a borozban voltam!');
             1: Write('-B- >> Egy '+ TVendeg(Vendegek[i-1]).GetNev +' lpett a borozba.');
        else
        end;

        end;

    if  (TVendeg(Vendegek[i-1]).GetHolvan = Borozo) then
        begin
        if (TVendeg(Vendegek[i-1]).GetRendelt = 0) or (TVendeg(Vendegek[i-1]).GetRendelt = 6) then   //vendeg elmegy ha teheti
            begin
            TVendeg(Vendegek[i-1]).Elmegy(Sehol);
            Borozo.DelVendeg(Borozo.SearchVendeg(TVendeg(Vendegek[i-1]).GetNev));
            TVendeg(Vendegek[i-1]).SetRendelt(-1);
            Write('-B- >> A '+ TVendeg(Vendegek[i-1]).GetNev +' tvozik az zletbl.');
            Continue;
            end;
        if (ran < VVRendel) then          // vendeg rendel VVRendel valoszinuseggel
                          begin
                          rendeles := TKiszolgal(TVendeg(Vendegek[i-1]).Rendel(FoBorasz));
                          SetIdok(FoBorasz);
                          if (TVendeg(Vendegek[i-1]).GetRendelt = -1) then TVendeg(Vendegek[i-1]).SetRendelt(1)
                                                                      else TVendeg(Vendegek[i-1]).SetRendelt(TVendeg(Vendegek[i-1]).GetRendelt + 1);
                          Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Nagyon finomak a borai! A kvetkezkbl rendelnk: ');
                          for j:=1 to rendeles.GetCountBorok do
                              begin
                              Write('            '+IntToStr(j)+'. '+ DoitForm.BorRag(TDolog(rendeles.GetItemBorok(j-1)).GetFajta) + IntToStr(TDolog(rendeles.GetItemBorok(j-1)).GetMennyiseg) +' '+ TDolog(rendeles.GetItemBorok(j-1)).GetEgyseg+ 't.');
                              end;
                          end;
        if (ran > VVRendel) and (ran < VVRendel + VVKostol) then    // vendeg kostol VVKostol valoszinuseggel
                          begin
                          bor := Random(6) + 1;
                          case bor of
                            1:begin
                              tmp := TVendeg(Vendegek[i-1]).Kostol(Borozo.SearchBor('Merlot'));
                              case tmp of
                                -2:Write('-V-ERROR >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Valamit gy megkstoltam volna, de hol van itt egy boroz?!?!');
                                -1:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Merlot-t kstoltam volna, de sajnos pp kifogyott... :o(');
                                 1:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Merlot-t kstoltam. Egszen zamatos!');
                                 2:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Merlot-t kstoltam. A sajt kihozza az aromit!');
                                 3:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Merlot-t kstoltam, de sajnos eltrtem a poharamat. Kaphatok egy msikat?');
                                 4:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Merlot-t kstoltam mikzben vletlenl lentttem a tertt. Elnzst!');
                              end;
                              end;
                            2:begin
                              tmp := TVendeg(Vendegek[i-1]).Kostol(Borozo.SearchBor('Bikavr'));
                              case tmp of
                                -2:Write('-V-ERROR >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Valamit gy megkostoltam volna, de hol van itt egy boroz?!?!');
                                -1:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Bikavrt kstoltam volna, de sajnos pp kifogyott... :o(');
                                 1:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Bikavrt kstoltam. Nekem kiss szraz! :o(');
                                 2:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Bikavrt kstoltam egy kis sajttal ksrve.');
                                 3:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Bikavrt kstoltam, de sajnos eltrtem a poharamat. Kaphatok egy msikat?');
                                 4:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Bikavrt kstoltam mikzben vletlenl lentttem a tertt. Elnzst! :o)');
                              end;
                              end;
                            3:begin
                              tmp := TVendeg(Vendegek[i-1]).Kostol(Borozo.SearchBor('Kkfrankos'));
                              case tmp of
                                -2:Write('-V-ERROR >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Valamit gy megkostoltam volna, de hol van itt egy boroz?!?!');
                                -1:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Kkfrankost kstoltam volna, de sajnos pp kifogyott... :o(');
                                 1:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Kkfrankost kstoltam. Nem rossz!');
                                 2:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Kkfrankost kstoltam egy kis sajttal. :o)');
                                 3:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Kkfrankost kstoltam, de sajnos eltrtem a poharamat. Kaphatok egy msikat?');
                                 4:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Kkfrankost kstoltam mikzben vletlenl lentttem a tertt. Elnzst!');
                              end;
                              end;
                            4:begin
                              tmp := TVendeg(Vendegek[i-1]).Kostol(Borozo.SearchBor('Asz'));
                              case tmp of
                                -2:Write('-V-ERROR >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Valamit gy megkostoltam volna, de hol van itt egy boroz?!?!');
                                -1:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Aszt kstoltam volna, de sajnos pp kifogyott... :o(');
                                 1:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Aszt kstoltam. Tl des nem gondolja?!');
                                 2:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Aszt kstoltam, gy sajttal nem volt olyan j.');
                                 3:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Aszt kstoltam, de sajnos eltrtem a poharamat. Kaphatok egy msikat? :o)');
                                 4:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Aszt kstoltam mikzben vletlenl lentttem a tertt. Elnzst!');
                              end;
                              end;
                            5:begin
                              tmp := TVendeg(Vendegek[i-1]).Kostol(Borozo.SearchBor('Olaszrizling'));
                              case tmp of
                                -2:Write('-V-ERROR >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Valamit gy megkostoltam volna, de hol van itt egy boroz?!?!');
                                -1:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Olaszrizlinget kstoltam volna, de sajnos pp kifogyott... :o(');
                                 1:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Olaszrizlinget kstoltam. Ez a legjobb! :o)');
                                 2:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Olaszrizlinget kstoltam, krhetek hozz egy kis sajtot? :o)');
                                 3:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Olaszrizlinget kstoltam, de sajnos eltrtem a poharamat. Kaphatok egy msikat?');
                                 4:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Olaszrizlinget kstoltam mikzben vletlenl lentttem a tertt. Elnzst!');
                              end;
                              end;
                            6:begin
                              tmp := TVendeg(Vendegek[i-1]).Kostol(Borozo.SearchBor('Szamorodni'));
                              case tmp of
                                -2:Write('-V-ERROR >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Valamit gy megkostoltam volna, de hol van itt egy boroz?!?!');
                                -1:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Szamorodnit kstoltam volna, de sajnos pp kifogyott... :o(');
                                 1:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Szamorodnit kstoltam. Ez is finom!');
                                 2:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Szamorodnit kstoltam s meg is ettem hozz j sok sajtot. :o)');
                                 3:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Szamorodnit kstoltam, de sajnos eltrtem a poharamat. Kaphatok egy msikat?');
                                 4:Write('-V- >> ['+ TVendeg(Vendegek[i-1]).GetNev + '] >> Szamorodnit kstoltam mikzben vletlenl lentttem a tertt. Elnzst! :o)');
                              end;
                              end;
                          end;

                          end;
        end;
    end;

                                               // ELLENORLEPES
ran := Random(100);
if (Ellenor.GetHolvan = Borozo) then
    begin
    if (Ellenor.GetMehet = True) then         // ellenor elmegy ha teheti
        begin
        Ellenor.Elmegy(Sehol);
        if (AuditForm.Showing = True) then AuditForm.Close;
        Write('-E- >> Megyek is. A Viszontltsra!');
        end
    else
        begin
        tmp := Ellenor.Vizsgal(FoBorasz);         // ellenor vizsgal
        case tmp of
           -1:begin
              Write('-E-ERROR >> Ellenriznk n szves-rmest, de itt nincs mit! Kint vagyok a prrin! :o)');
              end;
            1: begin
               Write('-E- >> Vgeztem a vizsglattal. Az eredmnyt ngyszemkzt kzlnm nnel...');
               AuditForm.ebETalalt.Text := 'hinyossgokat s ittas egynt is';
               AuditForm.ebECsinal.Text := 'KIRTTET s BNTET 1000 pnzre';
               end;
            2: begin
               Write('-E- >> Vgeztem a vizsglattal. Az eredmnyt ngyszemkzt kzlnm nnel...');
               AuditForm.ebETalalt.Text := 'nhny rszeget';
               AuditForm.ebECsinal.Text := 'BNTET 4500 pnzre';
               end;
            3: begin
               Write('-E- >> Vgeztem a vizsglattal. Az eredmnyt ngyszemkzt kzlnm nnel...');
               AuditForm.ebETalalt.Text := 'csak hinyossgokat';
               AuditForm.ebECsinal.Text := 'BNTET 500 pnzre';
               end;
            4: begin
               Write('-E- >> Vgeztem a vizsglattal. Az eredmnyt ngyszemkzt kzlnm nnel...');
               AuditForm.ebETalalt.Text := 'semmit az g vilgon';
               AuditForm.ebECsinal.Text := 'JUTALMAZ 1500 pnzt';
               end;
            5: begin
               Write('-E- >> Vgeztem a vizsglattal. Az eredmnyt ngyszemkzt kzlnm nnel...');
               AuditForm.ebETalalt.Text := 'hinyossgokat s ittas egynt is';
               AuditForm.ebECsinal.Text := 'KIRTTET s BNTET 2000 pnzre';
               end;
            6: begin
               Write('-E- >> Vgeztem a vizsglattal. Az eredmnyt ngyszemkzt kzlnm nnel...');
               AuditForm.ebETalalt.Text := 'ittas egyneket';
               AuditForm.ebECsinal.Text := 'KIRTTET';
               end;
            7: begin
               Write('-E- >> Vgeztem a vizsglattal. Az eredmnyt ngyszemkzt kzlnm nnel...');
               AuditForm.ebETalalt.Text := 'hinyossgokat';
               AuditForm.ebECsinal.Text := 'BNTET 2000 pnzre';
               end;
            8: begin
               Write('-E- >> Vgeztem a vizsglattal. Az eredmnyt ngyszemkzt kzlnm nnel...');
               AuditForm.ebETalalt.Text := 'semmit, de semmit';
               AuditForm.ebECsinal.Text := 'JUTALMAZ 1000 pnzt';
               end;
            9: begin
               Write('-E- >> Vgeztem a vizsglattal. Az eredmnyt ngyszemkzt kzlnm nnel...');
               AuditForm.ebETalalt.Text := 'rszegeket s hinyossgokat';
               AuditForm.ebECsinal.Text := 'KIRTTET s BNTET 3000 pnzre';
               end;
           10: begin
               Write('-E- >> Vgeztem a vizsglattal. Az eredmnyt ngyszemkzt kzlnm nnel...');
               AuditForm.ebETalalt.Text := 'rszegeket';
               AuditForm.ebECsinal.Text := 'KIRTTET';
               end;
           11: begin
               Write('-E- >> Vgeztem a vizsglattal. Az eredmnyt ngyszemkzt kzlnm nnel...');
               AuditForm.ebETalalt.Text := 'hinyossgokat';
               AuditForm.ebECsinal.Text := 'BNTET 2500 pnzre';
               end;
           12: begin
               Write('-E- >> Vgeztem a vizsglattal. Az eredmnyt ngyszemkzt kzlnm nnel...');
               AuditForm.ebETalalt.Text := 'semmit szerencsre';
               AuditForm.ebECsinal.Text := 'JUTALMAZ 500 pnzt';
               end;
        end;
        end;
    end
else
    begin
    if (ran < EVJon) and (Borozo.GetNyitva = True) then             // ellenor erkezik EVJon valoszinuseggel
        begin
        Ellenor.Elmegy(Borozo);
        Ellenor.SetMehet(False);
        AuditForm.Show;
        AuditUpdate;
        FoAblak.SetFocus;
        Write('-E- >> Jnapot! Ugye maga a tulajdonos? '+Ellenor.GetNev+' vagyok. A borozt jttem ellenrizni...');
        end;
    end;


                                                          // BORASZLEPES
if (FoBorasz.GetIdo = 0) then
    begin
    ran := Random(100);
    if (Borozo.GetCountVendegek = 0) and (Borozo.GetVanEllenor = False) then      // ha nincs vendeg
       begin
       if (ran < BVLeltaraz) then             // borasz leletaraz BVLeltaraz valoszinuseggel
           begin
           Leltaraz(FoBorasz);
           end
       end;
    if (Borozo.GetCountVendegek <> 0) then    // ha van vendeg
       begin
       if (ran < BVKiszolgal) then           // a borasz kiszolgal BVKiszolgal valoszinuseggel
           begin
           if (FoBorasz.GetCountKiszolgalas <> 0) then Kiszolgal(FoBorasz);
           end
       else
           begin
           end;
       end;
    end;
InfoUpdate;
Allapot('Folyamatban...');
end;

procedure TFoAblak.BtnSetupClick(Sender: TObject);
begin
Allapot('Belltsok...');
SetupAblak.ShowModal;
Allapot('Lelltva...');
end;

procedure TFoAblak.Write(s : String);               // rekurziv kiirofuggveny az esemenyek-listboxnak
var
  o : Integer;
  t : String;
  i : Integer;
  index : Integer;
begin
o:=19;
if (Length(s)<=95) then
    begin
    if (SetupAblak.rbOldal.Checked = True) then
        begin
        if (lbEvents.Count >= o) then
            begin
            while (lbEvents.Count >= o) do
                begin
                lbEvents.ClearSelection;
                lbEvents.Selected[0] := True;
                lbEvents.DeleteSelected;
                end;
            lbEvents.AddItem(s,nil);
            end
        else lbEvents.AddItem(s,nil);
        end;
    if (SetupAblak.rbSzaz.Checked = True) then
        begin
        if (lbEvents.Count >= 100) then
            begin
            while (lbEvents.Count >= 100) do
                begin
                lbEvents.ClearSelection;
                lbEvents.Selected[0] := True;
                lbEvents.DeleteSelected;
                end;
            lbEvents.AddItem(s,nil);
            end
        else
            begin
            lbEvents.AddItem(s,nil);
            end;
        if (lbEvents.Count > o) then lbEvents.TopIndex := lbEvents.Count - o;
        end;
    if (SetupAblak.rbOsszes.Checked = True) then
        begin
        lbEvents.AddItem(s,nil);
        if (lbEvents.Count > o) then lbEvents.TopIndex := lbEvents.Count - o;
        end;
    end
else
    begin
    index := 95;
    for i:=95 downto 1 do
        begin
        if (s[i]=' ') then
            begin
            index := i;
            System.Break;
            end;
        end;
    if (index < 45) then index := 95;
    SetLength(t,Length(s)-index);
    for i:=1 to Length(s)-index do
        begin
        t[i]:=s[index+i];
        s[index+i]:=#0;
        end;
    lbEvents.AddItem(s,nil);
    if (SetupAblak.rbOsszes.Checked = True) or (SetupAblak.rbSzaz.Checked = True) then
      begin
      if (lbEvents.Count > o) then lbEvents.TopIndex := lbEvents.Count - o;
      end;
    Write(t);
    end;
end;

procedure TFoAblak.lbTennivalokMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Hol : TPoint;
  index : Integer;
begin
Hol.X := X;
Hol.Y := Y;
index := lbTennivalok.ItemAtPos(Hol,True);
if (index = -1) then System.Exit;
DoitForm.SetAktualis(FoBorasz.GetItemTennivalo(index));
DoitForm.InfoUpdate;
if (DoitForm.Showing = False) then DoitForm.Show;
end;

procedure TFoAblak.lbBorokMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Hol : TPoint;
  index : Integer;
begin
Hol.X := X;
Hol.Y := Y;
index := lbBorok.ItemAtPos(Hol,True);
if (index = -1) then System.Exit;
ThingForm.SetAktualis(FoBorasz.GetUzlet.GetItemBorok(index));
ThingForm.InfoUpdate;
if (ThingForm.Showing = False) then ThingForm.Show;
end;

procedure TFoAblak.lbKellekekMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Hol : TPoint;
  index : Integer;
begin
Hol.X := X;
Hol.Y := Y;
index := lbKellekek.ItemAtPos(Hol,True);
if (index = -1) then System.Exit;
ThingForm.SetAktualis(FoBorasz.GetUzlet.GetItemKellekek(index));
ThingForm.InfoUpdate;
if (ThingForm.Showing = False) then ThingForm.Show;
end;

procedure TFoAblak.lbVendegekMouseDown(Sender: TObject;   Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Hol : TPoint;
  index : Integer;
  Igen, Nem : TPicture;
begin
Igen := TPicture.Create;
Nem := TPicture.Create;
Igen.Bitmap := check;
Nem.Bitmap := undo;
Hol.X := X;
Hol.Y := Y;
index := lbVendegek.ItemAtPos(Hol,True);
if (index = -1) then System.Exit;
GuestForm.SetAktualis(FoBorasz.GetUzlet.GetItemVendegek(index));
GuestForm.InfoUpdate;
if (GuestForm.Showing = False) then GuestForm.Show;
end;

procedure TFoAblak.FormShow(Sender: TObject);
begin
Allapot('Lelltva...');
if (Screen.Width < 800) then
    begin
    MessageDlg('FIGYELEM! Legalbb 800*600 -as felbonts ajnlott!', mtInformation, [mbOk],0);
    end;

if (Screen.Width >= 800) and (Screen.Width < 1024) then
    begin
    FoAblak.Top :=0;
    FoAblak.Left :=0;
    ThingForm.Top := FoAblak.Top;
    ThingForm.Left :=FoAblak.Left+FoAblak.Width;
    DoitForm.Top :=FoAblak.Top;
    DoitForm.Left :=FoAblak.Left+FoAblak.Width;
    SetupAblak.Top :=138;
    SetupAblak.Left :=133;
    GuestForm.Top :=FoAblak.Top + DoitForm.Height;
    GuestForm.Left :=FoAblak.Left+FoAblak.Width;
    AuditForm.Top :=FoAblak.Top + DoitForm.Height;
    AuditForm.Left :=FoAblak.Left+FoAblak.Width;
    end;
if (Screen.Width >= 1024) and (Screen.Width < 1280) then
    begin
    FoAblak.Top :=77;
    FoAblak.Left :=250;
    ThingForm.Top :=FoAblak.Top + DoitForm.Height;
    ThingForm.Left :=FoAblak.Left - ThingForm.Width;
    DoitForm.Top :=FoAblak.Top;
    DoitForm.Left :=FoAblak.Left - DoitForm.Width;
    SetupAblak.Top :=149;
    SetupAblak.Left :=209;
    GuestForm.Top :=FoAblak.Top;
    GuestForm.Left :=FoAblak.Left + FoAblak.Width;
    AuditForm.Top :=FoAblak.Top + GuestForm.Height;
    AuditForm.Left :=FoAblak.Left + FoAblak.Width;
    end;
if (Screen.Width >= 1280) then
    begin
    FoAblak.Top :=163;
    FoAblak.Left :=409;
    ThingForm.Top :=FoAblak.Top + DoitForm.Height;
    ThingForm.Left :=FoAblak.Left - ThingForm.Width;
    DoitForm.Top :=FoAblak.Top;
    DoitForm.Left :=FoAblak.Left - DoitForm.Width;
    SetupAblak.Top :=357;
    SetupAblak.Left :=359;
    GuestForm.Top :=FoAblak.Top;
    GuestForm.Left :=FoAblak.Left + FoAblak.Width;
    AuditForm.Top :=FoAblak.Top + GuestForm.Height;
    AuditForm.Left :=FoAblak.Left + FoAblak.Width;
    end;
end;

procedure TFoAblak.AuditUpdate;
begin
AuditForm.ebENev.Text := Ellenor.GetNev;
AuditForm.ebEHolvan.Text := Ellenor.GetHolvan.GetNev;
AuditForm.ebEHangulat.Text := Ellenor.GetHangulat;
end;

procedure TFoAblak.SetIdok (b : TBorasz);
var
  i : Integer;
begin
if (b = nil) then System.Exit;
for i:=1 to b.GetCountTennivalo do
    begin
    if (TTennivalo(b.GetItemTennivalo(i-1)).GetFajta = 'Kiszolgls') then TTennivalo(b.GetItemTennivalo(i-1)).SetIdo(StrToInt(SetupAblak.ebIkiszolg.Text));
    if (TTennivalo(b.GetItemTennivalo(i-1)).GetFajta = 'Borhozs')    then TTennivalo(b.GetItemTennivalo(i-1)).SetIdo(StrToInt(SetupAblak.ebIborthoz.Text));
    if (TTennivalo(b.GetItemTennivalo(i-1)).GetFajta = 'Vsrls')    then TTennivalo(b.GetItemTennivalo(i-1)).SetIdo(StrToInt(SetupAblak.ebIvasarol.Text));
    end;
end;

procedure TFoAblak.Leltaraz (b : TBorasz);
begin
if (b.GetIdo<>0) then System.Exit;
Write('-B- >> Krlnzek mibl vagyok fogytn. gysincs itt senki...');
b.AddIdo(StrToInt(SetupAblak.ebIleltar.Text));
b.SetMitCsinal(1);
end;

procedure TFoAblak.Kiszolgal (b : TBorasz);
begin
if (b.GetIdo<>0) then System.Exit;
Write('-B- >> Kiszolglok...');
b.AddIdo(StrToInt(SetupAblak.ebIkiszolg.Text));
b.SetMitCsinal(2);
end;

procedure TFoAblak.Borthoz (b : TBorasz);
begin
if (b.GetIdo<>0) then System.Exit;
Write('-B- >> Elmegyek borrt, aki itt van elkldm...');
b.AddIdo(StrToInt(SetupAblak.ebIborthoz.Text));
b.SetMitCsinal(3);
b.Elmegy(Pince);
end;

procedure TFoAblak.Vasarol (b : TBorasz);
begin
if (b.GetIdo<>0) then System.Exit;
Write('-B- >> Elmegyek vsrolni, aki itt van elkldm...');
b.AddIdo(StrToInt(SetupAblak.ebIborthoz.Text));
b.SetMitCsinal(4);
b.Elmegy(Szakbolt);
end;
{
procedure TFoAblak.VmitKiir (e : TEmber);
begin
MessageDlg(e.Kiir,mtInformation,[mbOk],0);
end;
 }
procedure TFoAblak.FormCreate(Sender: TObject);
begin
mHHelp := THookHelpSystem.Create('Borasz.chm', '', htHHAPI);
Application.OnHint:=DisplayHint;
end;

procedure TFoAblak.FormDestroy(Sender: TObject);
begin
mHHelp.Free;
HHCloseAll;
end;

procedure TFoAblak.artalom1Click(Sender: TObject);
begin
HtmlHelp(0,PChar('Borasz.chm'),HH_DISPLAY_TOPIC,0);
end;

procedure TFoAblak.Program1Click(Sender: TObject);
begin
ShellAbout(Handle, 'Borkeresked v1.2 PNY3-Edition', 'Csk Norbert & Magyar Attila 2003.05.25.', Application.Icon.Handle);
end;

procedure TFoAblak.Allapot(all: String);
begin
sbMain.Panels[0].Text:=all;
end;

procedure TFoAblak.DisplayHint(Sender: TObject);
var s: String;
begin
s:=GetLongHint(Application.Hint);
if (s<>'') then sbMain.Panels[1].Text:=s
           else sbMain.Panels[1].Text:='Borkeresked v1.2  -  Prognyelv3 edition';
end;

end.





