unit TennivaloForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, BoraszClasses;

type
  TDoitForm = class(TForm)
    Bevel1: TBevel;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    stBList: TStaticText;
    stKList: TStaticText;
    stVendeg: TStaticText;
    lbLista: TListBox;
    ebVendeg: TEdit;
    ebIdo: TEdit;
    ebNev: TEdit;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    Aktualis : Pointer;
  public
    function GetAktualis : Pointer;
    procedure SetAktualis(p : Pointer);
    procedure Clear;
    procedure InfoUpdate;
    procedure InfoCheck(b : TBorasz);
    function BorRag(i : Integer) : String; overload;
    function BorRag(s : String) : String; overload;
    function KellekRag(i : Integer) : String; overload;
    function KellekRag(s : String) : String; overload;
  end;

var
  DoitForm: TDoitForm;

implementation

{$R *.dfm}

procedure TDoitForm.Button1Click(Sender: TObject);
begin
DoitForm.Close;
end;

procedure TDoitForm.Clear;
begin
Aktualis := nil;
ebNev.Text := '';
ebIdo.Text := '';
lbLista.Clear;
ebVendeg.Text := '';
Close;
end;

procedure TDoitForm.InfoCheck(b : TBorasz);
begin
if (b.IsTennivalo(Aktualis) = False) then Clear;
end;

procedure TDoitForm.InfoUpdate;
var
  i : Integer;
begin
if (Aktualis = nil) then
    begin
    Clear;
    Close;
    Exit;
    end;
if (TTennivalo(Aktualis).GetFajta = 'Kiszolgls') then
    begin
    stVendeg.Enabled := True;
    stBList.Visible := True;
    stKList.Enabled := True;
    stKList.Visible := False;
    ebNev.Text := TKiszolgal(Aktualis).GetFajta;
    ebIdo.Text := IntToStr(TKiszolgal(Aktualis).GetIdo);
    ebVendeg.Text := TKiszolgal(Aktualis).GetVendeg.GetNev;
    lbLista.Clear;
    for i:=1 to TKiszolgal(Aktualis).GetCountBorok do
        begin
        lbLista.AddItem(BorRag(TDolog(TKiszolgal(Aktualis).GetItemBorok(i-1)).GetFajta) + IntToStr(TDolog(TKiszolgal(Aktualis).GetItemBorok(i-1)).GetMennyiseg) + ' '+ TDolog(TKiszolgal(Aktualis).GetItemBorok(i-1)).GetEgyseg, nil);
        end;
    end;
if (TTennivalo(Aktualis).GetFajta = 'Borhozs') then
    begin
    stVendeg.Enabled := False;
    stBList.Visible := True;
    stKList.Enabled := True;
    stKList.Visible := False;
    ebNev.Text := TBorthoz(Aktualis).GetFajta;
    ebIdo.Text := IntToStr(TBorthoz(Aktualis).GetIdo);
    ebVendeg.Text := '';
    lbLista.Clear;
    for i:=1 to TBorthoz(Aktualis).GetCountBorok do
        begin
        lbLista.AddItem(BorRag(TDolog(TBorthoz(Aktualis).GetItemBorok(i-1)).GetFajta) + IntToStr(TDolog(TBorthoz(Aktualis).GetItemBorok(i-1)).GetMennyiseg) + ' '+ TDolog(TBorthoz(Aktualis).GetItemBorok(i-1)).GetEgyseg, nil);
        end;
    end;
if (TTennivalo(Aktualis).GetFajta = 'Vsrls') then
    begin
    stVendeg.Enabled := False;
    stBList.Visible := False;
    stKList.Enabled := True;
    stKList.Visible := True;
    ebNev.Text := TVasarol(Aktualis).GetFajta;
    ebIdo.Text := IntToStr(TVasarol(Aktualis).GetIdo);
    ebVendeg.Text := '';
    lbLista.Clear;
    for i:=1 to TVasarol(Aktualis).GetCountKellekek do
        begin
        lbLista.AddItem(KellekRag(TDolog(TVasarol(Aktualis).GetItemKellekek(i-1)).GetFajta) + IntToStr(TDolog(TVasarol(Aktualis).GetItemKellekek(i-1)).GetMennyiseg) + ' '+ TDolog(TVasarol(Aktualis).GetItemKellekek(i-1)).GetEgyseg, nil);
        end;
    end;
if (TTennivalo(Aktualis).GetFajta = 'Semmilyen') then
    begin
    stVendeg.Enabled := False;
    stBList.Visible := False;
    stKList.Visible := True;
    stKList.Enabled := False;
    ebNev.Text := TTennivalo(Aktualis).GetFajta;
    ebIdo.Text := IntToStr(TTennivalo(Aktualis).GetIdo);
    ebVendeg.Text := '';
    lbLista.Clear;
    end;
end;

function TDoitForm.GetAktualis : Pointer;
begin
Result := Aktualis;
end;

procedure TDoitForm.SetAktualis(p : Pointer);
begin
Aktualis := p;
end;

procedure TDoitForm.FormCreate(Sender: TObject);
begin
Aktualis := nil;
end;

function TDoitForm.BorRag(i : Integer) : String;
begin
case i of
   1:Result:=' Merlotbl            ';
   2:Result:=' Bikavrbl          ';
   3:Result:=' Kkfrankosbl    ';
   4:Result:=' Aszbl               ';
   5:Result:=' Olaszrizlingbl     ';
   6:Result:=' Szamorodnibl    ';
else Result := ' HIBA ';
end;
end;

function TDoitForm.BorRag(s : String) : String;
begin
Result := ' HIBA ';
if (s = 'Merlot')       then Result:=' Merlotbl            ';
if (s = 'Bikavr')      then Result:=' Bikavrbl          ';
if (s = 'Kkfrankos')   then Result:=' Kkfrankosbl    ';
if (s = 'Asz')         then Result:=' Aszbl               ';
if (s = 'Olaszrizling') then Result:=' Olaszrizlingbl     ';
if (s = 'Szamorodni')   then Result:=' Szamorodnibl    ';
end;

function TDoitForm.KellekRag(i : Integer) : String;
begin
case i of
   1:Result:=' Kannbl   ';
   2:Result:=' Sajtbl       ';
   3:Result:=' Pohrbl    ';
   4:Result:=' Tertbl    ';
else Result := ' HIBA ';
end;
end;

function TDoitForm.KellekRag(s : String) : String;
begin
Result := ' HIBA ';
if (s = 'Kanna')  then Result:=' Kannbl   ';
if (s = 'Sajt')   then Result:=' Sajtbl       ';
if (s = 'Pohr')  then Result:=' Pohrbl    ';
if (s = 'Tert') then Result:=' Tertbl    ';
end;

end.
